'gbForumCode by Gary Beene
#Compile Exe
#Dim All

'#Debug Error On     'catch array/pointer errors - OFF in production
'#Debug Display On   'display untrapped errors   - OFF in production

#Include "Win32api.inc"
#Include "commctrl.inc"
#Include "richedit.inc"
#Resource "gbforumcode.pbr"

Declare Function Sub1( p1 As Any ) As Dword
Declare Function Sub2( p1 As Any, p2 As Any ) As Dword
Declare Function Sub3( p1 As Any, p2 As Any, p3 As Any ) As Dword
Declare Function Sub5( p1 As Any, p2 As Any, p3 As Any, p4 As Any, p5 As Any ) As Dword

Type CustomColors
   c(15) As Long
End Type

$CLSID_ShellLink = Guid$("{00021401-0000-0000-C000-000000000046}")
$IID_IShellLink = Guid$("{000214EE-0000-0000-C000-000000000046}")
$IID_IPersistFile = Guid$("{0000010B-0000-0000-C000-000000000046}")

%IDC_RichEdit       = 500
%IDC_Toolbar        = 501
%IDC_Chevron        = 502
%IDC_HiddenRichEdit = 503
%IDC_Find           = 504   'button
%IDC_Replace        = 505   'button
%IDC_Up             = 506
%IDC_Down           = 507
%IDC_Label          = 508
%IDC_FindText       = 509   'textbox
%IDC_ReplaceText    = 510   'textbox

%IDM_APILower       = 600
%IDM_APIMixed       = 601
%IDM_APIUpper       = 602
%IDM_KeyLower       = 603
%IDM_KeyMixed       = 604
%IDM_KeyUpper       = 605

%IDM_NoFont         = 650
%IDM_FixedPitch     = 651
%IDM_UseSyntax      = 652
%IDM_AutoLoadClip   = 653
%IDM_AsciITable     = 654
%IDM_Capture        = 655
%IDM_UseProcList    = 656
%IDM_TopMost        = 657
%IDM_HighlightSymbols = 658
%IDM_TopMostOnStart = 659


%IDM_Sep        = 700
%IDM_Cut        = 701
%IDM_Copy       = 702
%IDM_Paste      = 703
%IDM_Delete     = 704
%IDM_DeleteUnSel= 705
%IDM_Clear      = 706
%IDM_Sample     = 707
%IDM_CopyAll    = 708
%IDM_CodeInfo   = 709
%IDM_Find       = 710
%IDM_Print      = 711
%IDM_Format     = 712
%IDM_UndoFormat = 713

%IDM_zCommand   = 750
'%IDM_Build      = 751
%IDM_Debug      = 752
%IDM_Hide       = 753
%IDM_CompileTest= 754
%IDM_Compiler   = 755
%IDM_Include    = 756
%IDM_OpenInIDE  = 757
%IDM_PathInfo   = 758
%IDM_RunOnly    = 759
%IDM_DisplayMUser = 760

%IDT_CopyV      = 801
%IDT_ViewV      = 802
%IDT_Font       = 803
%IDT_Open       = 804
%IDT_Default    = 805
%IDT_Help       = 806
%IDT_Custom     = 807

'these need to stay in sequence
%IDT_Lower      = 850
%IDT_Mixed      = 851
%IDT_Upper      = 852
%IDT_Keyword    = 853
%IDT_Remark     = 854
%IDT_Symbol     = 855
%IDT_Number     = 856
%IDT_Assembler  = 857
%IDT_Quote      = 858
%IDT_API        = 859
%IDT_Back       = 860


Global rtfPrefix As String, rtfPostfix As String, endBlock As String, endKey As String
Global cKeyStr, cRemStr, cSymStr, cNumStr, cASMStr, cQuoStr, cAPIStr, cUserStr As String

Global apiStart() As Long, apiCount() As Long
Global keysStart() As Long, keysCount() As Long, fFindShown As Long
Global gPos As Long, gPtr As Long, gTxt As String, cLenStr, cLenEnd As Long

Global LKeys(), UKeys(), MKeys(), CFN, LastOpenedFile, LAPI(), UAPI(), MAPI() As String
Global LUser(), UUser(), MUser(), PathCompile, PathInclude, vCode As String
Global hRichEdit, hDlg, hContextRE, hContextMain,hToolbar, hMainImageList, hGraphic, hToolTip As Dword
Global hSearch, hFont, hPopupTBT, hPopupC, hPopupTBC,hConsole As Dword, OrigRichEditProc&
Global CustomColorList As CustomColors, SearchTerm$, ReplaceTerm$, SearchStart&
Global cKeyword, cRemark, cSymbol, cNumber, cAssembler, cQuote, cAPI, CodeCase, cBack As Long
Global FontName As String, FontSize, FontAttr, APICase, KeyCase, Debug, HighLightSymbols As Long
Global SmallToolbar, NoFont, FixedPitch, UseSyntax, AutoLoadClip, UseProcList, TopMost, TopMostOnStart As Long
Global UndoCode As String

Function PBMain() As Long
    'create some sample content for the RichEdit control
    Dialog New Pixels, 0, "gbForumCode " + GetVersionNumber,300,300,440,400, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
    DragAcceptFiles hDlg, %True
    Dialog Set Icon hDlg, "aalogo"
    Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local x,y,w,h,iReturn As Long, temp$, P As TOOLTIPTEXT Ptr, tempAsciiz As Asciiz * %Max_Path
   Select Case Cb.Msg
        Case %WM_InitDialog
            Settings_INI "get"
            hToolTip = CreateWindowEx(ByVal 0, "tooltips_class32", "", %TTS_ALWAYSTIP, 0, 0, 0, 0, ByVal hDlg, ByVal 0, GetModuleHandle(ByVal %NULL), ByVal 0)
            synInitializeRWords
            CreateRTFPrefix
            BuildAcceleratorTable
            CreateMainImageList
            CreateDropDownMenu
            ManageCustom(KeyCase)
            ManageCustom(APICase+3)
            CreateMainToolbar
            CreateRichEditControl
            SetRichEditFont
            SendMessage hRichEdit, %EM_SetBkgndColor, 0, cBack
            ResizeToolbar 0    '0=not resize dialog
            CreateContextMenu
            Menu Set State hContextMain, ByCmd %IDM_NoFont, NoFont * 8
            Menu Set State hContextMain, ByCmd %IDM_FixedPitch, FixedPitch * 8
            Menu Set State hContextMain, ByCmd %IDM_UseSyntax, UseSyntax * 8
            Menu Set State hContextMain, ByCmd %IDM_AutoLoadClip, AutoLoadClip * 8
            Menu Set State hContextMain, ByCmd %IDM_UseProcList, UseProcList * 8
            Menu Set State hContextMain, ByCmd %IDM_HighlightSymbols, HighlightSymbols * 8
            Menu Set State hContextMain, ByCmd %IDM_TopMostOnStart, TopMostOnStart * 8
            If TopMostOnStart Then TopMost = 1
            If TopMost Then SetWindowPos hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE
            Menu Set State hContextMain, ByCmd %IDM_TopMost, TopMost * 8

            CFN = EXE.Path$ + "gbforumcode_tmp.bas"
            If AutoLoadClip Then
                'fill RichEdit from ClipBoard
                Clipboard Get Text To temp$
                Control Set Text hDlg, %IDC_RichEdit, temp$
'                SendMessage hRichEdit, %WM_Paste, 0, 0
            ElseIf IsFile(CFN) Then
                LoadPreviouslySavedData
            Else
                'fill RichEdit with built-in sample data
                Control Set Text hDlg, %IDC_RichEdit, SampleCode
            End If
            If UseProcList Then BuildProcedureList
            FullSyntax
            If AutoLoadClip Then CopyVCode
            SetFocus hRichEdit

        Case %WM_Size
            Dialog Get Client Cb.Hndl To w,h
            Control Set Size Cb.Hndl, %IDC_RichEdit, w-20, h-70
            Control Set Loc hDlg, %IDC_Chevron, 0, h/2
            DrawChevron
            Control Show State hDlg, %IDC_Chevron, IIf(h<120, %SW_Hide, %SW_Show)

        Case %WM_DropFiles
            temp$ = GetDroppedFileName(Cb.WParam)
            DragFinish Cb.WParam
            If LCase$(Right$(temp$,4)) = ".lnk" Then temp$ = GetLinkInfo(temp$)
            If IsFile(temp$) Then
                Select Case LCase$(Right$(temp$,4))
                    Case ".bas", ".txt", ".inc"  : OpenSelectedFile(temp$)
                    Case Else : MsgBox "Wrong file type!", %MB_Ok+%MB_IconExclamation, "Open File"
                End Select
            Else
                MsgBox "Invalid File!", %MB_Ok+%MB_IconExclamation, "Open File"
            End If

        Case %WM_Notify
           Local nmtb As TBNOTIFY Ptr, rc As RECT
           nmtb = Cb.LParam

           If Cb.NmCode = %TTN_GetDispInfo Then
              P = Cb.LParam
              @P.@lpszText = SetToolTips(Cb.NmId)
            End If

            Select Case @nmtb.hdr.Code
               Case %TBN_DROPDOWN
                  Select Case @nmtb.iItem
                     Case %IDT_Custom
                        Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                        Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                        Call TrackPopupMenu (hPopUpTBT, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                     Case %IDT_Default
                        Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                        Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                        Call TrackPopupMenu (hPopUpTBC, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                     Case %IDM_CompileTest
                        Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                        Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                        Call TrackPopupMenu (hPopUpC, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                 End Select
            End Select

        Case %WM_Command
            Select Case Cb.Ctl
                Case %IDT_Open      : OpenSourceCodeFile

                Case %IDM_Cut
                    temp$ = GetRichEditSelectedText
                    SendMessage hRichEdit, %WM_Cut, 0, 0
                    Clipboard Reset
                    Clipboard Set Text temp$
                    If UseProcList Then BuildProcedureList
                    FullSyntax
                Case %IDM_Copy
                    temp$ = GetRichEditSelectedText
                    If Len(temp$) = 0 Then Control Get Text hDlg, %IDC_RichEdit To temp$
                    Clipboard Reset
                    Clipboard Set Text temp$
                Case %IDM_CopyAll
                    Clipboard Reset
                    Control Get Text hDlg, %IDC_RichEdit To temp$
                    Clipboard Set Text temp$
                Case %IDM_Paste
                    Clipboard Get Text temp$
                    Control Send hDlg, %IDC_RichEdit, %EM_ReplaceSel, %True, StrPtr(temp$)
                    If UseProcList Then BuildProcedureList
                    FullSyntax
                Case %IDM_Delete
                    SendMessage hRichEdit, %WM_Clear, 0, 0
                    If UseProcList Then BuildProcedureList
                    FullSyntax
                Case %IDM_DeleteUnSel
                    temp$ = GetRichEditSelectedText
                    Control Set Text hDlg, %IDC_RichEdit, temp$
                    If UseProcList Then BuildProcedureList
                    FullSyntax
                Case %IDM_Clear     : Control Set Text hDlg, %IDC_RichEdit, ""

                Case %IDT_CopyV   : CopyVCode
                Case %IDT_ViewV   : ViewVCode

                Case %IDT_Lower   : CodeCase = 1 : FullSyntax
                Case %IDT_Mixed   : CodeCase = 2 : FullSyntax
                Case %IDT_Upper   : CodeCase = 3 : FullSyntax
                Case %IDT_Custom  : CodeCase = 4 : FullSyntax

                Case %IDT_Font    : SelectFont  : SetRichEditFont : CreateRTFPrefix : FullSyntax
                Case %IDT_Default : RestoreDefaultColors


                Case %IDT_Keyword   :  ChangeColor(cKeyword)
                Case %IDT_Remark    :  ChangeColor(cRemark)
                Case %IDT_Symbol     :  ChangeColor(cSymbol)
                Case %IDT_Number    :  ChangeColor(cNumber)
                Case %IDT_Assembler :  ChangeColor(cAssembler)
                Case %IDT_Quote     :  ChangeColor(cQuote)
                Case %IDT_API       :  ChangeColor(cAPI)
                Case %IDT_Back      :  ChangeColor(cBack)

                Case %IDM_Sample
                    Control Set Text hDlg, %IDC_RichEdit, SampleCode
                    If UseProcList Then BuildProcedureList
                    FullSyntax
                Case %IDM_CodeInfo   : DisplayCodeInfo
                Case %IDM_Print      : PrintCode
                Case %IDM_Format
                    Control Get Text hDlg, %IDC_RichEdit To UndoCode
                    CodeIndent : FullSyntax
                Case %IDM_UndoFormat
                    Control Set Text hDlg, %IDC_RichEdit, UndoCode
                    FullSyntax
                Case %IDM_Find       : DisplayFindDialog

                Case %IDT_Help
                  tempAsciiZ = "http://www.garybeene.com/sw/gbforumcode.htm"
                  iReturn = ShellExecute(hDlg, "Open", tempAsciiZ, $Nul, $Nul, %SW_ShowNormal)

                Case %IDC_RichEdit
                    Select Case Cb.CtlMsg
                       Case %EN_Change    'applies to change on an individual lines
                        iReturn = SendMessage(hRichEdit, %EM_EXLINEFROMCHAR, 0, -1)
                        If UseProcList Then BuildProcedureList
                        ScanLine(iReturn, iReturn)               'check current line only
                    End Select

                Case %IDM_KeyLower : ManageCustom(1) : FullSyntax
                Case %IDM_KeyMixed : ManageCustom(2) : FullSyntax
                Case %IDM_KeyUpper : ManageCustom(3) : FullSyntax
                Case %IDM_APILower : ManageCustom(4) : FullSyntax
                Case %IDM_APIMixed : ManageCustom(5) : FullSyntax
                Case %IDM_APIUpper : ManageCustom(6) : FullSyntax

                Case %IDM_zCommand : zCommand
'                Case %IDM_Build    : BuildProcedureList : If UseProcList Then FullSyntax
                Case %IDM_DisplayMUser
                    MsgBox "Procedure List: " + $CrLf + "-----------" + $CrLf + Join$(MUser(), $CrLf), %MB_Ok + %MB_IconInformation, "User Functions"

                Case %IDM_Hide, %IDC_Chevron
                    SmallToolbar = SmallToolbar Xor 1
                    SetToolTip hGraphic, IIf$(SmallToolbar, "Minimal Toolbar", "ExpandToolbar")
                    ResizeToolbar(1)  '1= resize dialog
                Case %IDM_Debug
                    Debug = Debug Xor 1
                    If Debug = 0 Then FreeConsole : hConsole = 0
                Case %IDM_NoFont

                    NoFont = NoFont Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_NoFont, NoFont * 8
                Case %IDM_FixedPItch
                    FixedPitch = FixedPitch Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_FixedPitch, FixedPitch * 8
                Case %IDM_UseSyntax
                    UseSyntax = UseSyntax Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_UseSyntax, UseSyntax * 8
                    CreateRTFPrefix
                    FullSyntax
                Case %IDM_AutoLoadClip
                    AutoLoadClip = AutoLoadClip Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_AutoLoadClip, AutoLoadClip * 8
                Case %IDM_UseProcList
                    UseProcList = UseProcList Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_UseProcList, UseProcList * 8
                    If UseProcList Then BuildProcedureList
                    FullSyntax
                Case %IDM_HighLightSymbols
                    HighLightSymbols = HighLightSymbols Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_HighLightSymbols, HighlightSymbols * 8
                    If UseProcList Then BuildProcedureList
                    FullSyntax
                Case %IDM_TopMostOnStart
                    TopMostOnStart = TopMostOnStart Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_TopMostOnStart, TopMostOnStart * 8
                Case %IDM_TopMost
                    TopMost = TopMost Xor 1
                    Menu Set State hContextMain, ByCmd %IDM_TopMost, TopMost * 8
                    SetWindowPos hDlg, IIf(TopMost, %HWND_TOPMOST, %HWND_NOTOPMOST), 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE

                Case %IDM_AsciiTable   : AsciiTable
                Case %IDM_Capture      : Sleep 500 : keybd_event(%VK_SnapShot, 1, 0, 0)  'place active dialog on clipboard


                Case %IDM_Compiler     : SelectCompiler
                Case %IDM_Include      : SelectInclude
                Case %IDM_OpenInIDE    : OpenInIDE
                Case %IDM_RunOnly      : RunOnly
                Case %IDM_CompileTest  : CompileTest
                Case %IDM_PathInfo     : MsgBox PathCompile + $CrLf + PathInclude, %MB_Ok + %MB_IconInformation, "Compiler/Include Paths"
                Case %IDM_RunOnly      : RunOnly


            End Select
        Case %WM_ContextMenu
           x = Lo(Word,Cb.LParam) : y = Hi(Word, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
           TrackPopupMenu hContextMain, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
           Function = 0 : Exit Function
        Case %WM_Destroy
           Settings_INI "save"
           SaveCode
    End Select
End Function

Function TextWndProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local x,y As Long, temp$
  Select Case wMsg
    Case %WM_GETDLGCODE                 'establish control by the RichEdit
       Function = %DlgC_WantAllKeys
       Exit Function
    Case %WM_ContextMenu
       x = Lo(Word,LParam) : y = Hi(Word, LParam)    'WM_ContextMenu returns xy coordinates of mouse
       TrackPopupMenu hContextRE, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
       Exit Function
    Case %WM_Paste     'received before the paste occurs
       Control Post hDlg, %IDC_RichEdit, %WM_User+500, 0, 0   'delay this so will apply to posted text
    Case %WM_User + 500
       If UseProcList Then BuildProcedureList
       FullSyntax
    Case %WM_KeyDown
        If wParam = %VK_V And GetAsyncKeyState(%VK_Control) Then
          Clipboard Get Text To temp$
          Control Send hDlg, %IDC_RichEdit, %EM_ReplaceSel, %True, StrPtr(temp$)
          If UseProcList Then BuildProcedureList
          FullSyntax
          Exit Function
       End If
  End Select
  TextWndProc = CallWindowProc(OrigRichEditProc&, hWnd, wMsg, wParam, lParam)
End Function

Sub synInitializeRWords
  If debug Then cPrint "synInitializeRWords"
   Local temp$, i As Long
   ReDim UKeys(1000), LKeys(1000), MKeys(1000)
   ReDim UAPI(5000), LAPI(5000), MAPI(5000)

   Open EXE.Path$ + "gbforumcode_api.txt" For Input As #1
   While IsFalse Eof(1)
      Line Input #1, temp$
      If Len(Trim$(temp$)) Then
         MAPI(i) = temp$
         UAPI(i) = UCase$(temp$)
         LAPI(i) = LCase$(temp$)
         Incr i
      End If
   Wend
   Close #1
   ReDim Preserve UAPI(i-1), LAPI(i-1), MAPI(i-1)
   CreateAPIIndex

   i = 0
   Open EXE.Path$ + "gbforumcode_key.txt" For Input As #1
   While IsFalse Eof(1)
     Line Input #1, temp$
     If Len(Trim$(temp$)) Then
        MKeys(i) = temp$
        UKeys(i) = UCase$(MKeys(i))
        LKeys(i) = LCase$(MKeys(i))
        Incr i
     End If
   Wend
   Close #1
   ReDim Preserve UKeys(i-1), LKeys(i-1), MKeys(i-1)
   CreateKeysIndex

End Sub

Sub CreateKeysIndex
  Local ii,jj,kk As Long
  ReDim keysStart(26), keysCount(26)   'for index
  jj = 64  'Index on first character, $%&# = 0, A = 1, etc..
  For ii = 0 To UBound(UKeys)
     kk = Asc(UKeys(ii))
     If kk > jj Then    'A - Z
        keysCount(jj - 64) = Max&(0, ii - 1) 'indexed end
        jj = kk
        keysStart(kk - 64) = ii
     End If
  Next
  keysCount(jj - 64) = Max&(0, ii - 1)
  For ii = 0 To 26 're-calculate count
     If keysCount(ii) Then keysCount(ii) = Max&(0, keysCount(ii) - keysStart(ii) + 1)
  Next
End Sub

Sub CreateAPIIndex
  Local ii,jj,kk As Long
  ReDim apiStart(26), apiCount(26)   'for index
  jj = 64  'Index on first character, $%&# = 0, A = 1, etc..
  For ii = 0 To UBound(UAPI)
     kk = Asc(UAPI(ii))
     If kk > jj Then    'A - Z
        apiCount(jj - 64) = Max&(0, ii - 1) 'indexed end
        jj = kk
        apiStart(kk - 64) = ii
     End If
  Next
  apiCount(jj - 64) = Max&(0, ii - 1)
  For ii = 0 To 26 're-calculate count
     If apiCount(ii) Then apiCount(ii) = Max&(0, apiCount(ii) - apiStart(ii) + 1)
  Next
End Sub

Sub Settings_INI(Task$)
   Local i,x,y As Long
   Local xResult As Asciiz*%Max_Path, yResult As Asciiz*%Max_Path
   Local temp As Asciiz*%Max_Path, INIFileName As Asciiz*%Max_Path
   INIFileName = EXE.Path$ + "gbforumcode.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1050", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "610", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      Getprivateprofilestring "All", "ReplaceTerm", "", temp, %Max_Path, INIFileName
      ReplaceTerm$ = temp

      Getprivateprofilestring "All", "SearchTerm", "", temp, %Max_Path, INIFileName
      SearchTerm$ = temp

      Getprivateprofilestring "All", "PathCompile", "c:\pbwin90\bin\pbwin.exe", temp, %Max_Path, INIFileName
      PathCompile = temp

      Getprivateprofilestring "All", "PathInclude", "c:\pbwin90\winapi", temp, %Max_Path, INIFileName
      PathInclude = temp

      Getprivateprofilestring "All", "LastOpenedFile", EXE.Path$ + "gbforumcode_tmp.bas", temp, %Max_Path, INIFileName
      LastOpenedFile = temp

      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName
      FontSize = Val(temp)

      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName
      FontAttr = Val(temp)

      Getprivateprofilestring "All", "FontName", "Consolas", temp, %Max_Path, INIFileName
      FontName = temp

      Getprivateprofilestring "All", "NoFont", "0", temp, %Max_Path, INIFileName
      NoFont = Val(temp)

      Getprivateprofilestring "All", "FixedPitch", "0", temp, %Max_Path, INIFileName
      FixedPitch = Val(temp)

      Getprivateprofilestring "All", "AutoLoadClip", "0", temp, %Max_Path, INIFileName
      AutoLoadClip = Val(temp)

      Getprivateprofilestring "All", "UseSyntax", "1", temp, %Max_Path, INIFileName
      UseSyntax = Val(temp)

      Getprivateprofilestring "All", "UseProcList", "0", temp, %Max_Path, INIFileName
      UseProcList = Val(temp)

      Getprivateprofilestring "All", "HighlightSymbols", "1", temp, %Max_Path, INIFileName
      HighlightSymbols = Val(temp)

      Getprivateprofilestring "All", "TopMostOnStart", "0", temp, %Max_Path, INIFileName
      TopMostOnStart = Val(temp)

      Getprivateprofilestring "All", "TopMost", "0", temp, %Max_Path, INIFileName
      TopMost = Val(temp)

      Getprivateprofilestring "All", "SmallToolbar", "1", temp, %Max_Path, INIFileName
      SmallToolbar = Val(temp)

      Getprivateprofilestring "All", "APICase", "2", temp, %Max_Path, INIFileName
      APICase = Val(temp)

      Getprivateprofilestring "All", "KeyCase", "2", temp, %Max_Path, INIFileName
      KeyCase = Val(temp)

      Getprivateprofilestring "All", "CodeCase", "2", temp, %Max_Path, INIFileName
      CodeCase = Val(temp)

      Getprivateprofilestring "Color", "Keyword", "FF0000", temp, %Max_Path, INIFileName
      cKeyword = Val("&H" + temp)

      Getprivateprofilestring "Color", "Remark", "008000", temp, %Max_Path, INIFileName
      cRemark = Val("&H" + temp)

      Getprivateprofilestring "Color", "ESymbol", "0000FF", temp, %Max_Path, INIFileName
      cSymbol = Val("&H" + temp)

      Getprivateprofilestring "Color", "Number", "000040", temp, %Max_Path, INIFileName
      cNumber = Val("&H" + temp)

      Getprivateprofilestring "Color", "Assembler", "8F8F8F", temp, %Max_Path, INIFileName
      cAssembler = Val("&H" + temp)

      Getprivateprofilestring "Color", "Quote", "0000FF", temp, %Max_Path, INIFileName
      cQuote = Val("&H" + temp)

      Getprivateprofilestring "Color", "API", "FF0080", temp, %Max_Path, INIFileName
      cAPI = Val("&H" + temp)

      Getprivateprofilestring "Color", "Back", "FFFFFF", temp, %Max_Path, INIFileName
      cBack = Val("&H" + temp)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColorC" + Format$(i,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(temp)
      Next i

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save numeric variable
      temp = " " + SearchTerm$
      WritePrivateProfileString "All", "SearchTerm", temp, INIFileName

      temp = " " + ReplaceTerm$
      WritePrivateProfileString "All", "ReplaceTerm", temp, INIFileName

      temp = " " + PathCompile
      WritePrivateProfileString "All", "PathCompile", temp, INIFileName

      temp = " " + PathInclude
      WritePrivateProfileString "All", "PathInclude", temp, INIFileName

      temp = " " + LastOpenedFile
      WritePrivateProfileString "All", "LastOpenedFile", temp, INIFileName

      temp = " " + Str$(FontSize)
      WritePrivateProfileString "All", "FontSize", temp, INIFileName

      temp = " " + Str$(FontAttr)
      WritePrivateProfileString "All", "FontAttr", temp, INIFileName

      temp = " " + FontName
      WritePrivateProfileString "All", "FontName", temp, INIFileName

      temp = " " + Str$(NoFont)
      WritePrivateProfileString "All", "NoFont", temp, INIFileName

      temp = " " + Str$(FixedPitch)
      WritePrivateProfileString "All", "FixedPitch", temp, INIFileName

      temp = " " + Str$(AutoLoadClip)
      WritePrivateProfileString "All", "AutoLoadClip", temp, INIFileName

      temp = " " + Str$(UseSyntax)
      WritePrivateProfileString "All", "UseSyntax", temp, INIFileName

      temp = " " + Str$(UseProcList)
      WritePrivateProfileString "All", "UseProcList", temp, INIFileName

      temp = " " + Str$(HighlightSymbols)
      WritePrivateProfileString "All", "HighlightSymbols", temp, INIFileName

      temp = " " + Str$(TopMostOnStart)
      WritePrivateProfileString "All", "TopMostOnStart", temp, INIFileName

      temp = " " + Str$(TopMost)
      WritePrivateProfileString "All", "TopMost", temp, INIFileName

      temp = " " + Str$(SmallToolbar)
      WritePrivateProfileString "All", "SmallToolbar", temp, INIFileName

      temp = " " + Str$(APICase)
      WritePrivateProfileString "All", "APICase", temp, INIFileName

      temp = " " + Str$(KeyCase)
      WritePrivateProfileString "All", "KeyCase", temp, INIFileName

      temp = " " + Str$(CodeCase)
      WritePrivateProfileString "All", "CodeCase", temp, INIFileName

      temp = " " + Hex$(cKeyword,6)
      WritePrivateProfileString "Color", "Keyword", temp, INIFileName

      temp = " " + Hex$(cRemark,6)
      WritePrivateProfileString "Color", "Remark", temp, INIFileName

      temp = " " + Hex$(cSymbol,6)
      WritePrivateProfileString "Color", "ESymbol", temp, INIFileName

      temp = " " + Hex$(cNumber,6)
      WritePrivateProfileString "Color", "Number", temp, INIFileName

      temp = " " + Hex$(cAssembler,6)
      WritePrivateProfileString "Color", "Assembler", temp, INIFileName

      temp = " " + Hex$(cQuote,6)
      WritePrivateProfileString "Color", "Quote", temp, INIFileName

      temp = " " + Hex$(cAPI,6)
      WritePrivateProfileString "Color", "API", temp, INIFileName

      temp = " " + Hex$(cBack,6)
      WritePrivateProfileString "Color", "Back", temp, INIFileName

      For i = 0 To 15
         temp = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColorC" + Format$(i,"00"), temp, INIFileName
      Next i

   End If

End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub CreateRichEditControl
    'create RichEdit and subclass (to intercept %WM_KeyUp actions)
    LoadLibrary("riched32.dll")
    InitCommonControls

    'Visible Control
    Control Add "RichEdit", hDlg, %IDC_RichEdit, "", 10,60, 150, 60, _
              %WS_Child Or %WS_ClipSiblings Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or _
              %WS_HScroll Or %ES_NoHideSel or%ES_AutoVScroll Or %ES_AutoHScroll Or %ES_WantReturn, %WS_Ex_ClientEdge

    Control Handle hDlg, %IDC_RichEdit To hRichEdit
    OrigRichEditProc& = SetWindowLong(GetDlgItem(hDlg, %IDC_RichEdit), %GWL_WndProc, CodePtr(TextWndProc))
    SendMessage hRichEdit, %EM_SETEVENTMASK, 0, %ENM_SELCHANGE Or %ENM_CHANGE
    SendMessage hRichEdit, %EM_SetOptions, %ECOOP_OR, %ECO_SELECTIONBAR 'for left margin select..
    SendMessage(hRichEdit, %EM_EXLimitText, 0, 1000000)     'set new limit

    'and chevron graphic control
    Control Add Graphic, hDlg, %IDC_Chevron, "", 0,100,10,50, %SS_Notify
    Control Handle hDlg, %IDC_Chevron To hGraphic
    SetToolTip hGraphic, IIf$(SmallToolbar, "Minimal Toolbar", "ExpandToolbar")
    Graphic Attach hDlg, %IDC_Chevron
End Sub

Sub DrawChevron
    Local l,r,h,iColor As Long
    Graphic Clear

    Control Get Size hDlg, %IDC_RichEdit To r,h
    If h > 48 Then h = 48
    iColor = %Black
    l = 0 : r = 8
    If SmallToolbar Then
        Graphic Line (r,l)-(r,h), iColor
        Graphic Line (r,h)-(l,h/2), iColor
        Graphic Line (l,h/2)-(r,l), iColor
    Else
        Graphic Line (l,l)-(l,h), iColor
        Graphic Line (l,l)-(r,h/2), iColor
        Graphic Line (r,h/2)-(l,h), iColor
    End If
    Graphic Paint Border (5,h/2), %rgb_SlateGray, iColor

End Sub

Sub CopyVCode
    CreateVCode
    Clipboard Reset
    Clipboard Set Text vbHeader + vCode + vbFooter
End Sub

Sub ViewVCode
    CreateVCode
    Local iReturn As Long
    Open EXE.Path$ + "gbforumcode_vcode.txt" For Output As #1
    Print #1, vbHeader + vCode + vbFooter
    Close #1
    iReturn = Shell("notepad.exe " + EXE.Path$ + "gbforumcode_vcode.txt", 1)    'does not wait
End Sub

Sub CreateContextMenu
   Menu New PopUp To hContextRE
   Menu Add String, hContextRE, "Cut",  %IDM_Cut,  %MF_Enabled
   Menu Add String, hContextRE, "Copy", %IDM_Copy,  %MF_Enabled
   Menu Add String, hContextRE, "Copy All", %IDM_CopyAll,  %MF_Enabled
   Menu Add String, hContextRE, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, 0
   Menu Add String, hContextRE, "Delete Selected", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContextRE, "Delete UnSelected", %IDM_DeleteUnSel,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, 0
   Menu Add String, hContextRE, "Clear", %IDM_Clear,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, 0
   Menu Add String, hContextRE, "Find && Replace", %IDM_Find,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, 0
   Menu Add String, hContextRE, "Format Code", %IDM_Format,  %MF_Enabled
   Menu Add String, hContextRE, "Undo Formatting", %IDM_UndoFormat,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, 0
   Menu Add String, hContextRE, "Load Sample Code", %IDM_Sample,  %MF_Enabled
   Menu Add String, hContextRE, "Display Code Summary", %IDM_CodeInfo,  %MF_Enabled
   Menu Add String, hContextRE, "Print Code", %IDM_Print,  %MF_Enabled

   Menu New PopUp To hContextMain
   Menu Add String, hContextMain, "Use vBulletin Default Font",  %IDM_NoFont,  %MF_Enabled
   Menu Add String, hContextMain, "Fixed Pitch Fonts",  %IDM_FixedPitch,  %MF_Enabled
   Menu Add String, hContextMain, "AutoLoad Clipboard on Start",  %IDM_AutoLoadClip,  %MF_Enabled
   Menu Add String, hContextMain, "-", %IDM_Sep, 0
   Menu Add String, hContextMain, "Use Syntax Highlighting",  %IDM_UseSyntax,  %MF_Enabled
   Menu Add String, hContextMain, "Highlight User Procedures", %IDM_UseProcList,  %MF_Enabled
   Menu Add String, hContextMain, "Highlight Symbols", %IDM_HighLightSymbols,  %MF_Enabled
   Menu Add String, hContextMain, "-", %IDM_Sep, 0
   Menu Add String, hContextMain, "Topmost on Startup", %IDM_TopMostOnStart,  %MF_Enabled
   Menu Add String, hContextMain, "Set As Topmost", %IDM_TopMost,  %MF_Enabled
   Menu Add String, hContextMain, "-", %IDM_Sep, 0
   Menu Add String, hContextMain, "Ascii Table", %IDM_AsciiTable,  %MF_Enabled
   Menu Add String, hContextMain, "Capture Dialog", %IDM_Capture,  %MF_Enabled
   Menu Add String, hContextMain, "-", %IDM_Sep, 0
   Menu Add String, hContextMain, "Display Procedure List", %IDM_DisplayMUser,  %MF_Enabled

End Sub

Sub SaveCode
    Local temp$
    'save the code
    temp$ = "gbforumcode_tmp.bas"
    If IsFile(temp$) Then Kill temp$
    Open EXE.Path$ + temp$ For Binary As #1
    Control Get Text hDlg, %IDC_RichEdit To Temp$
    Put$ #1, temp$
    Close #1
End Sub

Sub SetRichEditFont
   Font New FontName, FontSize, FontAttr To hFont
   Control Set Font hDlg, %IDC_RichEdit, hFont
End Sub

Sub CreateMainToolbar
    Local hTips As Dword
    Control Kill hDlg, %IDC_Toolbar
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Border Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    hTips = SendMessage(GetDlgItem(hDlg, %IDC_Toolbar), %TB_GETTOOLTIPS, 0, 0)
    SetWindowLong hTips, %GWL_STYLE, GetWindowLong(hTips, %GWL_STYLE) Or %TTS_ALWAYSTIP

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hMainImageList, 0    'attach imagelist

    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDM_Clear,  %TbStyle_Button, "Clear"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDM_Cut,    %TbStyle_Button, "Cut"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDM_Copy,   %TbStyle_Button, "Copy"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDM_Paste,  %TbStyle_Button, "Paste"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDM_Delete, %TbStyle_Button, "Delete"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_CopyV,   %TbStyle_Button, "CopyV"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_ViewV,   %TbStyle_Button, "View"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 17, %IDM_CompileTest,   %TbStyle_Button Or %TbStyle_DropDown, "Compile"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Lower,   %TbStyle_Check Or %TbStyle_Group, "Lower"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Mixed,   %TbStyle_Check Or %TbStyle_Group, "Mixed"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Upper,   %TbStyle_Check Or %TbStyle_Group, "Upper"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 16, %IDT_Custom,   %TbStyle_Check Or %TbStyle_DropDown Or %TbStyle_Group, "Custom"
    If SmallToolbar = 0 Then Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Font,    %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_Default,    %TbStyle_Button Or %TbStyle_DropDown, "Colors"
    If SmallToolbar = 0 Then Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 18, %IDT_Keyword,   %TbStyle_Button, "Key"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 19, %IDT_Remark,    %TbStyle_Button, "Rem"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 20, %IDT_Symbol,    %TbStyle_Button, "Sym"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 21, %IDT_Number,    %TbStyle_Button, "Num"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 22, %IDT_Assembler, %TbStyle_Button, "ASM"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 23, %IDT_Quote,     %TbStyle_Button, "Quo"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 24, %IDT_API,       %TbStyle_Button, "API"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 25, %IDT_Back,       %TbStyle_Button, "Bkgnd"
    If SmallToolbar = 0 Then Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_Help,       %TbStyle_Button, "Help"

    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd Choose(CodeCase, %IDT_Lower, %IDT_Mixed, %IDT_Upper, %IDT_Custom), %TBState_Enabled Or %TBState_Checked

End Sub

Sub CreateMainImageList
    ImageList Kill hMainImageList
    ImageList New Icon 24,24,32,50 To hMainImageList
    ImageList Add Icon hMainImageList, "new"           '1
    ImageList Add Icon hMainImageList, "cut"           '2
    ImageList Add Icon hMainImageList, "copy"          '3
    ImageList Add Icon hMainImageList, "paste"         '4
    ImageList Add Icon hMainImageList, "delete"        '5
    ImageList Add Icon hMainImageList, "copyv"         '6
    ImageList Add Icon hMainImageList, "view"          '7
    ImageList Add Icon hMainImageList, "font"          '8
    ImageList Add Icon hMainImageList, "lower"         '9
    ImageList Add Icon hMainImageList, "mixed"         '10
    ImageList Add Icon hMainImageList, "upper"         '11
    ImageList Add Icon hMainImageList, "font2"         '12
    ImageList Add Icon hMainImageList, "open"          '13
    ImageList Add Icon hMainImageList, "help"          '14
    ImageList Add Icon hMainImageList, "default"       '15
    ImageList Add Icon hMainImageList, "customa"       '16
    ImageList Add Icon hMainImageList, "compile"       '17

    ImageList Add Icon hMainImageList, CreateColorIcon(cKeyword)
    ImageList Add Icon hMainImageList, CreateColorIcon(cRemark)
    ImageList Add Icon hMainImageList, CreateColorIcon(cSymbol)
    ImageList Add Icon hMainImageList, CreateColorIcon(cNumber)
    ImageList Add Icon hMainImageList, CreateColorIcon(cAssembler)
    ImageList Add Icon hMainImageList, CreateColorIcon(cQuote)
    ImageList Add Icon hMainImageList, CreateColorIcon(cAPI)
    ImageList Add Icon hMainImageList, CreateColorIcon(cBack)
End Sub

Function SetToolTips(cID As Long) As String
  Select Case cID          'or this:   @P.hdr.idFrom
    Case %IDT_Open           : Function = "Open Existing File"
    Case %IDM_Clear          : Function = "Delete All Text"
    Case %IDM_Cut            : Function = "Cut Selection"
    Case %IDM_Copy           : Function = "Copy Selection (all if no selection)"
    Case %IDM_Paste          : Function = "Paste Text From Clipboard"
    Case %IDM_Delete         : Function = "Delete Selected Text"
    Case %IDT_CopyV          : Function = "Copy vBulletin Code To Clipboard"
    Case %IDT_ViewV          : Function = "Open vBulletin Code in NotePad"
    Case %IDM_CompileTest    : Function = "Compile Only"

    Case %IDT_Font           : Function = "Font (" + FontName + "," + Str$(FontSize ) + "," + GetFontDesc

    Case %IDT_Upper          : Function = "Upper Case"
    Case %IDT_Lower          : Function = "Lower Case"
    Case %IDT_Mixed          : Function = "Mixed Case"
    Case %IDT_Custom         : Function = "Custom Case"

    Case %IDT_Default        : Function = "Restore Default Colors"

    Case %IDT_Keyword       : Function = "Keywords"
    Case %IDT_Remark        : Function = "Remarks"
    Case %IDT_Symbol        : Function = "ESymbols"
    Case %IDT_Number        : Function = "Numbers"
    Case %IDT_Assembler     : Function = "Assembler"
    Case %IDT_Quote         : Function = "Quotes"
    Case %IDT_API           : Function = "API"
    Case %IDT_Back          : Function = "BackGround"

    Case %IDT_Help          : Function = "Online Help"
  End Select
End Function

Function CreateColorIcon(iColor As Long) As Dword
   Local B As Bitmap, iPos,x,w,h As Long, bmp$
   Local hBMPXOR, hBMPAND As Dword, P As IconInfo

   'Create an XOR bitmap using the bitstring in bmp$
   w = 16 : h = 16
   Graphic Bitmap New w,h To hBMPXOR
   Graphic Attach hBMPXOR, 0
   Graphic Clear iColor
   Graphic Get Bits To bmp$

   'create the bit array for the monochrome MASK bitmask. &HECE9D8 is transparent color
   Dim Mask(1 To w*h/8) As Static Byte
   For x = 9 To Len(bmp$) Step 4
      If Cvl(bmp$,x) = &HECE9D8 Then
         Bit Set Mask(1),(iPos And &hfffffff8) + 7 - (iPos And &h7)   'bit is transparent
      Else
         Bit Reset Mask(1),(iPos And &hfffffff8) + 7 - (iPos And &h7) 'bit is not transparent
      End If
      Incr iPos
   Next

   'fill out the MASK bitmap variable information
   B.bmType = 0           :   B.bmWidth = w    :   B.bmHeight = h
   B.bmWidthBytes = w/8   :   B.bmPlanes = 1   :   B.bmBitsPixel = 1
   B.bmBits = VarPtr(Mask(1))

   'create the MASK bitmap
   hBMPAND = CreateBitmapIndirect(B)

   'fill in the ICONINFO variable and create the icon (.xHotSpot/.yHotSpot are ignored)
   P.fIcon = %True
   P.hbmColor = hBMPXOR
   P.hbmMask = hBMPAND
   Function = CreateIconIndirect (P)
End Function

Sub ChangeColor(iColor As Long)
    Local iTemp As Long
    iTemp = iColor
    iTemp = SelectColor(iColor)
    If iColor = iTemp Then Exit Sub
    iColor = iTemp
    CreateMainImageList
    CreateMainToolbar
    ResizeToolbar(0)   '0= not resize dialog
    SendMessage hRichEdit, %EM_SetBkgndColor, 0, cBack
    CreateRTFPrefix
    FullSyntax
End Sub

Sub SelectFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   If FixedPitch Then
       Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_FixedPitchOnly
   Else
       Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations
   End If

   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName
      FontSize = fPoints
      FontAttr = fStyle
   End If
End Sub

Function GetFontDesc() As String
    Select Case FontAttr
        Case 0 : Function = "Normal"
        Case 1 : Function = "Bold"
        Case 2 : Function = "Italic"
        Case 3 : Function = "Bold-Italic"
    End Select
End Function

Sub RestoreDefaultColors
    cKeyword=   &HFF0000
    cRemark=    &H008000
    cSymbol=    &H0000FF
    cNumber=    &H000040
    cAssembler= &H8F8F8F
    cQuote=     &H0000FF
    cAPI=       &HFF0080
    CreateMainImageList
    CreateMainToolbar
    ResizeToolbar(0)   '0= not resize dialog
    CreateRTFPrefix
    FullSyntax
End Sub

Sub OpenSourceCodeFile
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select File"    'caption title. if "", then "Open" is displayed
    filter$ = Chr$("Source Code",0,"*.bas;*.inc",0)
    startfolder$ = LastOpenedFile    'initial folder to be displayed
    startfile$ = LastOpenedFile       'name to be used as initial selection
    defaultext$ = "bas"                 'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, _
                              defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then OpenSelectedFile(filevar$)
End Sub

Function vbHeader() As String
    Local temp$
    If NoFont Then
        temp$ = "[co" + "de]"
    Else
        temp$ = "[co" + "de][fo" + "nt=" + FontName + "]"
        If FontSize > 14 Then
            temp$ = temp$ + "[si" + "ze=+2]"
        ElseIf FontSize > 10 Then
            temp$ = temp$ + "[si" + "ze=+1]"
        End If
        temp$ = temp$ + Choose$(FontAttr, "[b"+"]","[i"+"]","[b"+"][i"+"]")
    End If
    Function = temp$
End Function

Function vbFooter() As String
    Local temp$
    If NoFont Then
        temp$ = "[/co" + "de]"
    Else
        temp$ = "[/fo" + "nt][/co" + "de]
        If FontSize > 10 Then temp$ = "[/si" + "ze]" + temp$
        temp$ = Choose$(FontAttr, "[/"+"b]","[/"+"i]","[/"+"i][/"+"b]") + temp$
    End If
    Function = temp$
End Function

Sub CreateDropDownMenu
  Menu New PopUp To hPopupTBT
  Menu Add String, hPopupTBT, "Key Lower", %IDM_KeyLower, %MF_Enabled
  Menu Add String, hPopupTBT, "Key Mixed", %IDM_KeyMixed, %MF_Enabled
  Menu Add String, hPopupTBT, "Key Upper", %IDM_KeyUpper, %MF_Enabled
  Menu Add String, hPopupTBT, "-", 0, 0
  Menu Add String, hPopupTBT, "API/User Lower", %IDM_APILower, %MF_Enabled
  Menu Add String, hPopupTBT, "API/User Mixed", %IDM_APIMixed, %MF_Enabled
  Menu Add String, hPopupTBT, "API/User Upper", %IDM_APIUpper, %MF_Enabled

  Menu New PopUp To hPopupTBC
  Menu Add String, hPopupTBC, "Keyword", %IDT_Keyword, %MF_Enabled
  Menu Add String, hPopupTBC, "Remark", %IDT_Remark, %MF_Enabled
  Menu Add String, hPopupTBC, "Symbols", %IDT_Symbol, %MF_Enabled
  Menu Add String, hPopupTBC, "Number", %IDT_Number, %MF_Enabled
  Menu Add String, hPopupTBC, "Assembler", %IDT_Assembler, %MF_Enabled
  Menu Add String, hPopupTBC, "Quote", %IDT_Quote, %MF_Enabled
  Menu Add String, hPopupTBC, "API", %IDT_API, %MF_Enabled
  Menu Add String, hPopupTBC, "Background", %IDT_Back, %MF_Enabled

  Menu New PopUp To hPopupC   'compiler
  Menu Add String, hPopupC, "Compile Only", %IDM_CompileTest, %MF_Enabled
  Menu Add String, hPopupC, "Open In IDE", %IDM_OpenInIDE, %MF_Enabled
  Menu Add String, hPopupC, "-", 0, 0
  Menu Add String, hPopupC, "Run Existing EXE", %IDM_RunOnly, %MF_Enabled
  Menu Add String, hPopupC, "-", 0, 0
  Menu Add String, hPopupC, "Select Compiler", %IDM_Compiler, %MF_Enabled
  Menu Add String, hPopupC, "Select Include Path", %IDM_Include, %MF_Enabled
  Menu Add String, hPopupC, "Display Paths", %IDM_PathInfo, %MF_Enabled

End Sub

Sub ManageCustom(Flag As Long)
   Select Case Flag
       Case 1 To 3
           Menu Set State hPopupTBT, ByCmd %IDM_KeyLower, 0
           Menu Set State hPopupTBT, ByCmd %IDM_KeyMixed, 0
           Menu Set State hPopupTBT, ByCmd %IDM_KeyUpper, 0
       Case 4 To 6
           Menu Set State hPopupTBT, ByCmd %IDM_APILower, 0
           Menu Set State hPopupTBT, ByCmd %IDM_APIMixed, 0
           Menu Set State hPopupTBT, ByCmd %IDM_APIUpper, 0
   End Select

   Select Case Flag
       Case 1 : Menu Set State hPopupTBT, ByCmd %IDM_KeyLower, 8 : KeyCase = 1
       Case 2 : Menu Set State hPopupTBT, ByCmd %IDM_KeyMixed, 8 : KeyCase = 2
       Case 3 : Menu Set State hPopupTBT, ByCmd %IDM_KeyUpper, 8 : KeyCase = 3
       Case 4 : Menu Set State hPopupTBT, ByCmd %IDM_APILower, 8 : APICase = 1
       Case 5 : Menu Set State hPopupTBT, ByCmd %IDM_APIMixed, 8 : APICase = 2
       Case 6 : Menu Set State hPopupTBT, ByCmd %IDM_APIUpper, 8 : APICase = 3
   End Select
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(4)
'   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_B     : ac(c).cmd   = %IDM_Build       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D     : ac(c).cmd   = %IDM_Debug       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H     : ac(c).cmd   = %IDM_Hide        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z     : ac(c).cmd   = %IDM_ZCommand    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U     : ac(c).cmd   = %IDM_DisplayMUser: Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F     : ac(c).cmd   = %IDM_Find        : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CPrint (txtA As String)
    Static cWritten, iMsgCount As Long
    Local SOut As String
    Incr iMsgCount : If iMsgCount& > 999999 Then iMsgCount& = 1
    SOut = Format$(iMsgCount&,"* ###0") + " " + txtA
    If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
    WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
End Sub

Sub ResizeToolbar(SizeDlg As Long)
    Local i,w,h As Long
    Dialog Get Size hDlg To w,h

    If SmallToolbar Then
        For i = %IDT_Lower To %IDT_Back : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd i, %TBState_Enabled : Next i
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20 At 17   'separator
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20 At 20   'separator
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20 At 29   'separator
        If SizeDlg Then Dialog Set Size hDlg, 1050,h
    Else
        Toolbar Delete Button hDlg, %IDC_Toolbar, 29   'separator
        Toolbar Delete Button hDlg, %IDC_Toolbar, 20   'separator
        Toolbar Delete Button hDlg, %IDC_Toolbar, 17   'separator
        For i = %IDT_Lower To %IDT_Back :  Toolbar Set State hDlg, %IDC_Toolbar, ByCmd i, %TBState_Hidden : Next i
        If SizeDlg Then Dialog Set Size hDlg, 610,h
'        Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Custom, %TBState_Enabled Or %TBState_Checked
        CodeCase = 4
    End If
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd Choose(CodeCase, %IDT_Lower, %IDT_Mixed, %IDT_Upper, %IDT_Custom), %TBState_Enabled Or %TBState_Checked
    Control ReDraw hDlg, %IDC_Toolbar

    DrawChevron
End Sub

Function GetVersionNumber() As String
   Local szSourceFile As Asciiz * %MAX_PATH
   Local InfoSize, lpdwHandle, dwHandle, Minor As Long
   Local sBuf As String, pFI As VS_FIXEDFILEINFO Ptr
   GetModuleFileName ByVal %Null, szSourceFile, SizeOf(szSourceFile)
   InfoSize = GetFileVersionInfoSize(szSourceFile, lpdwHandle)
   If InfoSize = 0 Then Exit Function
   sBuf = Space$(InfoSize)
   If GetFileVersionInfo(szSourceFile, dwHandle, InfoSize, ByVal StrPtr(sbuf)) = 0 Then Exit Function
   If VerQueryValue(ByVal StrPtr(sBuf), "\", pFI, InfoSize) = 0 Then Exit Function
   Minor = LoWrd(@pFI.dwFileVersionMS)
   If Minor Mod 10 = 0 Then
     Minor = Minor\10
   End If
   sBuf  = Format$(HiWrd(@pFI.dwFileVersionMS), "0") & "." & Format$(Minor, "#0")
   If @pFI.dwFileVersionLS Then
      sBuf  = sBuf + "." + Format$(HiWrd(@pFI.dwFileVersionLS), "0")
   End If
   Function = sBuf
End Function

Sub CompileTest
   Local CmdString, temp, tempFile As String, iReturn As Dword
   On Error GoTo CompileError

   If IsFalse(IsFile(PathCompile)) Then
       MsgBox "PowerBASIC compiler not found!" + $CrLf + PathCompile, %MB_Ok + %MB_IconInformation, "Compile & Execute"
       Exit Sub
   End If

   'create temp *_temp.bas file in same place as *.bas file
   SaveCode
   tempFile = EXE.Path$ + "gbforumcode_tmp.bas"
   CmdString = PathCompile + " /I" + $Dq + PathInclude + $Dq + " /L /Q " + $Dq + tempFile + $Dq
   Shell CmdString, 1     'run compiler, wait for it to execute

   'check log file for error
   Open EXE.Path$ + "gbforumcode_tmp.log" For Binary As #1
   Get$ #1, Lof(1), temp$    'filedata$ will contain $crlf's from the file
   Close #1                      'LOF() returns number of bytes in an Open file
   If InStr(LCase$(temp$),"error") Then  'ask user if wants to open log file
      If MsgBox ("Error during compilation. Open compile log?", %MB_OkCancel Or %MB_IconInformation, "Compile Only") = %IdOk Then
         iReturn = Shell("notepad.exe " + EXE.Path$ + "gbforumcode_tmp.log", 1)   'does not wait
      End If
   Else
      If MsgBox ("Compile was successful! Open compile log?", %MB_OkCancel Or %MB_IconInformation, "Compile Only") = %IdOk Then
         iReturn = Shell("notepad.exe " + EXE.Path$ + "gbforumcode_tmp.log", 1)   'does not wait
      End If
   End If

   Exit Sub

CompileError:
    MsgBox "Error " + Str$(Err) + " " + Error$(Err)

End Sub


Sub SelectCompiler
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select Compiler"    'caption title. if "", then "Open" is displayed
    filter$ = "PBWin Compiler" + $Nul + "*.exe" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = PathCompile    'initial folder to be displayed
    startfile$ = PathCompile       'name to be used as initial selection
    defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, _
                              defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
        PathCompile = filevar$
    Else
        'no action ESC or cancel
    End If
End Sub

Sub SelectInclude
   Local title$, start$, flags&, folder$
   title$ = "Select Path to Include Files"    'if "" then "Open" is used
   start$ = PathInclude
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$
   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then
      PathInclude = folder$
   Else
      'no action - ESC or Cancel
   End If
End Sub

Sub OpenInIDE
    Local fName As Asciiz * %Max_Path, iReturn As Long, temp$
    Control Get Text hDlg, %IDC_RichEdit To temp$
    fName = EXE.Path$ + "gbforumcode_tmp.bas"
    Open fName For Output As #1
    Print #1, temp$
    Close #1
    iReturn = ShellExecute(hDlg, "Open", fName, $Nul, $Nul, %SW_ShowNormal)
End Sub

Function SampleCode() As String
    Local Content$
    Content =  "'Sample Code"  + $CrLf + _
               "#Compile Exe"  + $CrLf + _
               "#Dim All"  + $CrLf + _
               "#Include " + Chr$(34) + "Win32API.inc" + Chr$(34)  + $CrLf + _
               "Global hDlg As Dword"  + $CrLf + _
               "Function PBMain() As Long"  + $CrLf + _
               "   Dialog New Pixels,0," + Chr$(34) + "Test" + Chr$(34) + ",,,200,200,%WS_OverlappedWindow To hDlg"  + $CrLf + _
               "   Control Add Button, hDlg, 100," + Chr$(34) + "Push" + Chr$(34) + ", 50,10,100,20"  + $CrLf + _
               "   Dialog Show Modal hDlg Call DlgProc"  + $CrLf + _
               "End Function"  + $CrLf + _
               ""  + $CrLf + _
               "CallBack Function DlgProc() As Long"  + $CrLf + _
               "   Select Case Cb.Msg"  + $CrLf + _
               "      Case %WM_Command"  + $CrLf + _
               "         Select Case CB.Ctl"  + $CrLf + _
               "            Case 100"  + $CrLf + _
               "               ? DisplayTime"  + $CrLf + _
               "         End Select"  + $CrLf + _
               "   End Select"  + $CrLf + _
               "End Function"  + $CrLf + _
               ""  + $CrLf + _
               "Function DisplayTime() As String"  + $CrLf + _
               "   Function = " + Chr$(34) + "Time is:  " + Chr$(34) + " + Time$"  + $CrLf + _
               "End Function"  + $CrLf
    Function = content$
'               "   Function = (GetUserName(StrPtr(temp),SizeOf(temp))) + " + Chr$(34) + ", the time is:  " + Chr$(34) + " + Time$"  + $CrLf + _
End Function

Sub ASCIITable
   Local temp() As String, i As Long, all$
   Dim temp(32)
   For i = 0 To 31
      temp(i) = Chr$(i+33) + Chr$(9) + Str$(i+33)
   Next i
   For i = 0 To 31
      temp(i) = temp(i) + Chr$(9) + Chr$(i+65) + Chr$(9) + Str$(i+65)
   Next i
   For i = 0 To 31
      temp(i) = temp(i) + Chr$(9) + Chr$(i+97) + Chr$(9) + Str$(i+97) + Chr$(9)
   Next i
   all$ = Join$(temp(), $CrLf)
   all$ = all$ + $CrLf + $CrLf + " 0  null" + $Tab + $Tab + "12  formfeed (FF)"
   all$ = all$ + $CrLf + " 8  backspace" + $Tab + "13  carriage return (CR)"
   all$ = all$ + $CrLf + " 9  tab" + $Tab + $Tab + "27  escape (ESC)"
   all$ = all$ + $CrLf + "10  linefeed (LF)" + $Tab + "32  space"

   MsgBox all$, %MB_Ok, "ASCII Table"
End Sub

Sub RunOnly
    Local tempEXE$, iReturn As Long
    tempEXE$ = EXE.Path$ + "gbforumcode_tmp.exe"
    If IsFile(tempEXE$) Then
       iReturn = Shell(tempEXE)       'run EXE, not wait
    Else
       MsgBox "Cannot locate EXE file!" , %MB_Ok + %MB_IconInformation, "Execute Existing EXE"
    End If
End Sub

Sub zCommand
    ? Join$(Muser(),$CrLf)
Exit Sub
   Dim iStart As Long, iEnd As Long
   iStart = GetTickCount
   If UseProcList Then BuildProcedureList
   FullSyntax
   iEnd = GetTickCount
   ? Format$((iEnd - iStart)/1000,3) & " seconds"
End Sub

Sub BuildProcedureList
   If debug Then cPrint "buildprocedurelist"
   Local i, pCount As Long, tmp$, ProcListBuf$
   Local w1$, w2$, w3$, w4$, s1$, s2$, s3$, s4$, s12$

   ReDim MUser(1000)
   Control Get Text hDlg, %IDC_RichEdit To ProcListBuf$
   Dim BufArray(ParseCount(ProcListBuf$,$CrLf)-1) As String   'break input string into an array
   Parse ProcListBuf$, BufArray(), $CrLf

   For i = 0 To UBound(BufArray)
      tmp$ = LTrim$(Retain$(BufArray(i), Any Chr$(65 To 90, 95, 97 To 122, 48 To 57, $Spc, "()=")))
      Replace Any "()" With "  " In tmp$
      While InStr(tmp$, "  ") : Replace "  " With " " In tmp$ : Wend  'remove all pairs of spaces
      w1$ = Parse$(tmp$," ",1) : w2$ = Parse$(tmp$," ",2) : w3$ = Parse$(tmp$," ",3) : w4$ = Parse$(tmp$," ",4)
      s1$ = LCase$(w1$) : s2$ = LCase$(w2$) : s3$ = LCase$(w3$) : s4$ = LCase$(w4$) : s12$ = Build$(s1$," ",s2$)
      If s1$   = "sub"                           Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "callback function"             Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "function" And w2$ <> "="       Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "macro function"                Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "macro"                         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "thread function"               Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "class"                         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "class method"                  Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s12$  = "override method"               Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "method" And w2$ <> "="         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s1$   = "interface"                     Then MUser(pCount) = w2$ : Incr pCount : Iterate For
   Next i

   ReDim Preserve MUser(IIf(pCount>0, pCount-1, pCount))
   ReDim Preserve LUser(UBound(MUser)), UUser(UBound(MUser))
   Array Sort MUser()
   For i = 0 To UBound(MUser) : LUser(i) = LCase$(MUser(i)) : UUser(i) = UCase$(MUser(i)) : Next i
End Sub

Sub LoadPreviouslySavedData
    Local temp$
    'fill RichEdit from saved data
    Open CFN For Binary As #1
    Get$ #1, Lof(1), temp$
    Close #1
    Control Set Text hDlg, %IDC_RichEdit, temp$
End Sub

Function BinaryWordSearch_User(sWord As String, iPos As Long) As Long
    Local Upper, Lower As Long
    Lower = LBound(UUser) : Upper = UBound(UUser)
    'test boundary values
    If sWord = UUser(Lower) Then iPos& = Lower : Function = 1 : Exit Function
    If sWord = UUser(Upper) Then iPos& = Upper : Function = 1 : Exit Function
    If sWord < UUser(Lower) Then iPos& = Lower - 1 : Function = 0 : Exit Function
    If sWord > UUser(Upper) Then iPos& = Upper + 1 : Function = 0 : Exit Function
    'search the rest of the array
    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        If sWord > UUser(iPos&) Then
           Lower = iPos
        ElseIf sWord < UUser(iPos&) Then
           Upper = iPos
        Else
           Function = 1 : Exit Function
        End If
    Loop
End Function

Function BinaryWordSearch_Key(sWord As String, iPos As Long) As Long
    Local Upper, Lower As Long
    Lower = LBound(UKeys) : Upper = UBound(UKeys)
    'test boundary values
    If sWord = UKeys(Lower) Then iPos& = Lower : Function = 1 : Exit Function
    If sWord = UKeys(Upper) Then iPos& = Upper : Function = 1 : Exit Function
    If sWord < UKeys(Lower) Then iPos& = Lower - 1 : Function = 0 : Exit Function
    If sWord > UKeys(Upper) Then iPos& = Upper + 1 : Function = 0 : Exit Function
    'search the rest of the array
    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        If sWord > UKeys(iPos&) Then
           Lower = iPos
        ElseIf sWord < UKeys(iPos&) Then
           Upper = iPos
        Else
           Function = 1 : Exit Function
        End If
    Loop
End Function

Function BinaryWordSearch_API(sWord As String, iPos As Long) As Long
    Local Upper, Lower As Long
    Lower = LBound(UAPI) : Upper = UBound(UAPI)
    'test boundary values
    If sWord = UAPI(Lower) Then iPos = Lower : Function = 1 : Exit Function
    If sWord = UAPI(Upper) Then iPos = Upper : Function = 1 : Exit Function
    If sWord < UAPI(Lower) Then iPos = Lower - 1 : Function = 0 : Exit Function
    If sWord > UAPI(Upper) Then iPos = Upper + 1 : Function = 0 : Exit Function
    'search the rest of the array
    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        If sWord > UAPI(iPos) Then
           Lower = iPos
        ElseIf sWord < UAPI(iPos) Then
           Upper = iPos
        Else
           Function = 1 : Exit Function
        End If
    Loop
End Function

Sub FullSyntax
' Convert text to RTF and insert into Rich Edit
  Local eStream As EDITSTREAM, Oldpd As CharRange
  MousePtr 11             'show Hourglass mouse pointer during process
  Control Get Text hDlg, %IDC_RichEdit To gtxt
  SendMessage(hRichEdit, %EM_EXGETSEL, 0, VarPtr(Oldpd)) 'Original position
                                                          '(so we can reset it later)
  Call SyntaxColorBAS  'convert PB code to RTF - this is also fast
  gPos                = 1             'position in text to start from
  gPtr                = StrPtr(gTxt)  'pointer to global text buffer
  eStream.pfnCallback = CodePtr(RichEditStreamInString) 'pointer to RichEdit callback procedure
  SendMessage hRichEdit, %EM_STREAMIN, %SF_RTF, VarPtr(eStream) 'stream in text
  MousePtr 1       'done, so time to reset mouse pointer
'  gTxt = ""        'and we can clear global string buffer

  'Reset original caret position
  SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(Oldpd))
End Sub

Function RichEditStreamInString (ByVal dwCookie As Dword, ByVal pbBuff As Byte Ptr, _
                                 ByVal cb As Long, pcb As Long) As Dword
' Rich Edit stream in callback - for streaming in string contents
  pcb = Min&(cb, Len(gTxt) - (gPos - 1)) 'number of bytes to copy

  If pcb > 0 Then        'copy block from global string directly into Richedit's buffer.
     CopyMemory pbBuff, (gPtr + gPos - 1), pcb  'could use POKE$ too, but this is a bit faster
     gPos = gPos + pcb   'incr pos for next callback position.
  Else
     Function = 1        'else break action
  End If

End Function

Sub CreateRTFPrefix
  Local temp$
  temp$ = Choose$(FontAttr+1,"", "\b" , "\i", "\b\i")
  rtfPrefix =  "{\rtf1\ansi \deff0" + _
               "{\fonttbl{\f0\fs" + Format$(2*FontSize,"00") + "\fnil " + FontName + ";}}" + _  'RTF header
               "{\colortbl;\red255\green255\blue255;" + _  'cf1, white
               "\red0\green0\blue0;" + _                   'cf2, black
               "\red" + Format$(cKeyword Mod 256,"000")   + "\green" + Format$((cKeyword\256) Mod 256,"000")   + "\blue" + Format$((cKeyword\256\256) Mod 256,"000") + ";" + _   'cf3 keys
               "\red" + Format$(cRemark Mod 256,"000")    + "\green" + Format$((cRemark\256) Mod 256,"000")    + "\blue" + Format$((cRemark\256\256) Mod 256,"000") + ";" + _    'cf4 remarks
               "\red" + Format$(cSymbol Mod 256,"000")    + "\green" + Format$((cSymbol\256) Mod 256,"000")    + "\blue" + Format$((cSymbol\256\256) Mod 256,"000") + ";" + _    'cf5 symbols
               "\red" + Format$(cNumber Mod 256,"000")    + "\green" + Format$((cNumber\256) Mod 256,"000")    + "\blue" + Format$((cNumber\256\256) Mod 256,"000") + ";" + _    'cf6 numbers
               "\red" + Format$(cAssembler Mod 256,"000") + "\green" + Format$((cAssembler\256) Mod 256,"000") + "\blue" + Format$((cAssembler\256\256) Mod 256,"000") + ";" + _ 'cf7 asm
               "\red" + Format$(cQuote Mod 256,"000")     + "\green" + Format$((cQuote\256) Mod 256,"000")     + "\blue" + Format$((cQuote\256\256) Mod 256,"000") + ";" + _     'cf8 quotes
               "\red" + Format$(cAPI Mod 256,"000")       + "\green" + Format$((cAPI\256) Mod 256,"000")       + "\blue" + Format$((cAPI\256\256) Mod 256,"000") + ";}" + _      'cf9 api
               "\deftab1134\margl0\margt0\margr0\margb0\plain" + temp$ + "\f0\fs" + Format$(2*FontSize,"00") + " "
  temp$ = Choose$(FontAttr+1,"", "\b0" , "\i0", "\b0\i0")
  rtfPostfix = "\n" + temp$ + "\par }"         'RTF end

  'starting blocks
  cKeyStr    = IIf$(UseSyntax, "\cf3 ", "\cf2 ")    'Keys
  cRemStr    = IIf$(UseSyntax, "\cf4 ", "\cf2 ")    'Remarks
  cSymStr    = IIf$(UseSyntax, "\cf5 ", "\cf2 ")    'Symbols
  cNumStr    = IIf$(UseSyntax, "\cf6 ", "\cf2 ")    'Numbers
  cASMStr    = IIf$(UseSyntax, "\cf7 ", "\cf2 ")    'ASM
  cQuoStr    = IIf$(UseSyntax, "\cf8 ", "\cf2 ")    'Quotes
  cAPIStr    = IIf$(UseSyntax, "\cf9 ", "\cf2 ")    'API
  cUserStr   = IIf$(UseSyntax, "\cf9 ", "\cf2 ")    'User (same color as API)
  cLenStr = Len(cKeyStr)

  'ending blocks
  endBlock   = "\cf2 "    'black, default value
  endKey     = "\cf2b"    'temporary block
  cLenEnd = Len(endBlock)
End Sub

Sub SyntaxColorBAS
' Parser builds syntax colored RTF. Use pointers and pre-allocated output string for speed
  Local ii As Long, stopPos As Long, Result As Long, iPos As Long
  Local wFlag As Long, remFlag As Long, dqFlag As Long, cWordStr As String, slashFlag As Long
  Local pLet As Byte Ptr, pLet2 As Byte Ptr
  Local tmpWord As String, outBuf As String, uCaseBuf As String

  gTxt = gTxt + " "                'add a space to ensure last word will be checked if nothing follows it
  Replace "\" With "\\" In gTxt    'RTF needs this to understand backslash
  Replace "{" With "\{" In gTxt    'RTF needs this to understand {
  Replace "}" With "\}" In gTxt    'RTF needs this to understand }
  OutBuf   = String$(Max&(1000, 10 * Len(gTxt)), 0) 'create enough big output buffer
  uCaseBuf = UCase$(gTxt)          'use uppercase string for compare
  pLet     = StrPtr(gTxt)          'pointer to global string (input)
  pLet2    = StrPtr(OutBuf)        'pointer to output buffer
  For ii = 1 To Len(gTxt)
     Select Case @pLet            'the characters we need to inlude in a word
        Case 65 To 90, 97 To 122, 35 To 37, 48 To 57, 63, 95, 46
           If wFlag = 0 And remFlag = 0 And dqFlag = 0 Then
              wFlag = 1 : stopPos = ii
           End If

        Case 34 ' double quote -> "
           If dqFlag = 0 And remFlag = 0 Then  'if start of string literal
              Poke$ pLet2, cQuoStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
              dqFlag = 1 : wFlag = 0                              'since now inside DQ, wordflag is off
           ElseIf dqFlag = 1 Then                                 'should be end of DQ block
              @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
              Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
              dqFlag = 3                                          'end of DQ - set DQ flag
           End If

        Case 59 ' asm comment character -> ;
           If remFlag = 0 And dqFlag = 2 Then
              Poke$ pLet2, endBlock   :  pLet2 = pLet2 + cLenEnd   'put endblock, move pointer
              Poke$ pLet2, cRemStr    :  pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              remFlag = 1 : wFlag = 0
           End If

        Case 39 ' uncomment character -> '
           If remFlag = 0 And dqFlag <> 1 Then
              If dqFlag = 2 Then
                 Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd   'put endblock, move pointer
              End If
              Poke$ pLet2, cRemStr     : pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              remFlag = 1 : wFlag = 0
           End If

        Case 33 ' asm line start -> !
           If remFlag = 0 And dqFlag = 0 Then
              Poke$ pLet2, cASMStr     : pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              dqFlag = 2 : wFlag = 0
           End If

        Case Else  'word is ready
           If @pLet = 13 Then    'if CRLF - end of line
              If remFlag Or dqFlag Then   'if in rem, asm or unfinished string literal (DQ)
                 Poke$ pLet2, endBlock  : pLet2 = pLet2 + cLenEnd   'put value, move pointer
                 remFlag = 0 : wFlag = 0 : dqFlag = 0  'reset all flags
              End If
           End If

           If wFlag = 1 Then 'if we have a word
              tmpWord = Mid$(uCaseBuf, stopPos, ii - stopPos)  'Get word
              Result = 0

              If BinaryWordSearch_Key(tmpWord,iPos) Then
                  tmpWord = Choose$(IIf(CodeCase<4,CodeCase,KeyCase),LKeys(iPos), MKeys(iPos), UKeys(iPos))
                  cWordStr = cKeyStr : Result = 1
              ElseIf BinaryWordSearch_API(tmpWord,iPos) Then
                  tmpWord = Choose$(IIf(CodeCase<4,CodeCase,APICase),LAPI(iPos), MAPI(iPos), UAPI(iPos))
                  cWordStr = cAPIStr : Result = 1
              ElseIf UseProcList And BinaryWordSearch_User(tmpWord,iPos) Then
                  tmpWord = Choose$(IIf(CodeCase<4,CodeCase,APICase),LUser(iPos), MUser(iPos), UUser(iPos))
                  cWordStr = cUserStr : Result = 1
              End If

              If Result Then   'word match found (API, Keyword, User)
                 If LCase$(tmpWord) = "rem" Then
                    pLet2 = pLet2 - 3                                      'position to start of word
                    Poke$ pLet2, cRemStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                    Poke$ pLet2, tmpWord   : pLet2 = pLet2 + 3             'put value, move opinter
                    remFlag = 1
                 ElseIf LCase$(tmpWord) = "asm" Then
                    pLet2 = pLet2 - 3                                      'position to start of word
                    Poke$ pLet2, cASMStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                    Poke$ pLet2, tmpWord   : pLet2 = pLet2 + 3             'put value, move pointer
                    dqFlag = 2
                 Else
                     pLet2 = pLet2 - Len(tmpWord)                          'position to start of word
                     Poke$ pLet2, cWordStr  : pLet2 = pLet2 + cLenStr      'put preblock, move pointer
                     Poke$ pLet2, tmpWord   : pLet2 = pLet2 + Len(tmpWord) 'put value, move pointer
                     Poke$ pLet2, endKey    : pLet2 = pLet2 + cLenEnd '15  'put endblock, move pointer
                 End If
              ElseIf Verify(tmpWord, ".0123456789") = 0 Then
                     pLet2 = pLet2 - Len(tmpWord) 'set position to start of word
                     Poke$ pLet2, cNumStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                     Poke$ pLet2, tmpWord   : pLet2 = pLet2 + Len(tmpWord)  'put value, move pointer
                     Poke$ pLet2, endBlock  : pLet2 = pLet2 + cLenEnd       'put endblock, move pointer
              End If
              wFlag = 0
           End If
     End Select


     If dqFlag <> 3 Then
         If (remFlag = 0) And (dqFlag = 0) And HighlightSymbols Then
            Select Case @pLet   'Chr$(@Letter)
    '               =   *   +   -   /   <   >   ^   (  )
              Case  61, 42, 43, 45, 47, 60, 62, 94, 40, 41   ' 92=\ missing
                 Poke$ pLet2, cSymStr     : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                 @pLet2 = @pLet           : pLet2 = pLet2 + 1           'put value, move pointer
                 Poke$ pLet2, endBlock    : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
              Case  92  ' "\"
                 If slashFlag = 0 Then
                    Poke$ pLet2, cSymStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    slashFlag = 1
                 ElseIf Peek(pLet+1)<>92 Then
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
                    slashFlag = 0
                 Else
                    @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
                 End If
              Case  38  ' "&"
                 If Peek(pLet-1)=32 And Peek(pLet+1)=32 Then
                    Poke$ pLet2, cSymStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
                 Else
                    @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
                 End If
              Case Else
                 @pLet2 = @pLet           : Incr pLet2                  'put char, move pointer
            End Select
         Else
             @pLet2 = @pLet               :  Incr pLet2                 'put char, move pointer
         End If
     Else
        dqFlag = 0             'else reset DQ flag
     End If
     Incr pLet                 'move pointer to next character
  Next ii

  gTxt = Extract$(OutBuf, Chr$(32, 0))      'extract result (and remove the added space)
  Replace endKey + " " + cKeyStr With " " In gTxt    'Trim size: If keywords follows each other,
  Replace endKey With endBlock In gTxt               'replace remaining Key endblocks with proper RTF

  Replace $CrLf With "\par " In gTxt    'RTF likes this kind of line feed better

  gTxt = rtfPrefix + gTxt + rtfPostfix  'combine RTF header + result + end string
End Sub

Function setRichTextColor( ByVal NewColor As Long, ByVal iLine As Long) As Long
'  If debug Then cPrint "setRichTextColor"
' setRichTextColor sets the textcolor for selected text in a Richedit control.
' &HFF - read, &HFF0000 - blue, &H008000 - dark green, &H0 is black, etc.
   Local cf As CHARFORMAT
   cf.cbSize      = Len(cf)       'Length of structure
   cf.dwMask      = %CFM_COLOR    'Set mask to colors only
   cf.crTextColor = NewColor      'Set the new color value
   If UseSyntax Then SendMessage(hRichEdit, %EM_SETCHARFORMAT, %SCF_SELECTION, VarPtr(cf))
End Function

Sub TurnOffCol
  If debug Then cPrint "TurnOffCol"
' Set all text to black - faster this way
  Local cf As CHARFORMAT, xEvent As Long
  xEvent = SendMessage(hRichEdit, %EM_GETEVENTMASK, 0, 0)         'Get eventmask
  SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, 0)            'Disable eventmask
  MousePtr 11                                                'Hourglass
  cf.cbSize      = Len(cf)                                   'Length of structure
  cf.dwMask      = %CFM_COLOR                                'Set mask to colors only
  cf.crTextColor = &H0                                       'Set black color value
  SendMessage(hRichEdit, %EM_SETCHARFORMAT, -1, VarPtr(cf)) '%SCF_ALL = -1
  If xEvent Then SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, xEvent)     'Enable eventmask
  MousePtr 0
End Sub

Sub ScanLine(ByVal Line1 As Long, ByVal Line2 As Long)

  If debug Then cPrint "ScanLine"
' Syntax color parser for received line numbers
  Local pd As CHARRANGE, Oldpd As CHARRANGE, tBuff As TEXTRANGE
  Local xWord As String, Buf As String, cWord As Long
  Local Aspect As Long, xEvents As Long, I As Long , J As Long, stopPos As Long
  Local lnLen, iPos, Result As Long, wFlag As Byte, Letter As Byte Ptr

  SendMessage(hRichEdit, %EM_EXGETSEL, 0, VarPtr(Oldpd)) 'Original position
                                                          '(so we can reset it later)
  'Disable the event mask, for better speed
  xEvents = SendMessage(hRichEdit, %EM_GETEVENTMASK, 0, 0)
  SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, 0)

  'Turn off redraw for faster and smoother action
'  SendMessage(hRichEdit, %WM_SETREDRAW, 0, 0)
  SendMessage(hRichEdit, %EM_HideSelection, 1, 0)

  If Line1 <> Line2 Then                                  'if multiple lines
     MousePtr 11
  Else                                                                     'editing a line
     pd.cpMin = SendMessage(hRichEdit, %EM_LINEINDEX, Line1, 0)                'line start
     pd.cpMax = pd.cpMin + SendMessage(hRichEdit, %EM_LINELENGTH, pd.cpMin, 0) 'line end
     SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))                  'select line
     setRichTextColor &H0, -1                                             'set black, all lines
  End If

  For J = Line1 To Line2
     Aspect = SendMessage(hRichEdit, %EM_LINEINDEX, J, 0)       'line start
     lnLen  = SendMessage(hRichEdit, %EM_LINELENGTH, Aspect, 0) 'line length

     If lnLen Then
        Buf = Space$(lnLen + 1)
        tBuff.chrg.cpMin = Aspect
        tBuff.chrg.cpMax = Aspect + lnLen
        tBuff.lpstrText = StrPtr(Buf)
        lnLen = SendMessage(hRichEdit, %EM_GETTEXTRANGE, 0, ByVal VarPtr(tBuff)) 'Get line

        CharUpperBuff(ByVal StrPtr(Buf), lnLen)        'Make UCASE
        'I always use this one, since it handles characters > ASC(127) as well.. ;-)

        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ' Loop through the line, using a pointer for better speed
        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        Letter = StrPtr(Buf) : wFlag = 0
        For I = 1 To Len(Buf)
           Select Case @Letter 'The characters we need to inlude in a word
              Case 97 To 122, 65 To 90, 192 To 214, 216 To 246, 248 To 255, _
                                                 35 To 37, 48 To 57, 63, 95, 46
                 If wFlag = 0 Then
                    wFlag = 1 : stopPos = I
                 End If

              Case 34 ' string quotes -> "
                stopPos = InStr(I + 1, Buf, Chr$(34)) 'Find match
                If stopPos Then
                   pd.cpMin = Aspect + I - 1  : pd.cpMax = Aspect + stopPos
                   SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                   setRichTextColor cQuote, J
                   StopPos = (StopPos - I)   ' + 1)
                   I = I + StopPos
                   Letter = Letter + StopPos
                   wFlag = 0
                End If

              Case 39 ' normal code comment character -> '
                 pd.cpMin = Aspect + I - 1   : pd.cpMax = Aspect + lnLen
                 SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                 setRichTextColor cRemark, J
                 wFlag = 0
                 Exit For

              Case 33 ' ASM line start character
                 stopPos = InStr(I + 1, Buf, Chr$(59)) 'look for assembler comment ;
                 If stopPos Then
                    'found a ; comment mark
                    'color assembler
                    pd.cpMin = Aspect + I - 1  : pd.cpMax = Aspect + stopPos - 1
                    SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                    setRichTextColor cAssembler, J
                    StopPos = (StopPos - I + 1)
                    I = I + StopPos
                    Letter = Letter + StopPos
                    'comment the rest
                    pd.cpMin = Aspect + I - 2 : pd.cpMax = Aspect + lnLen
                    SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                    setRichTextColor cRemark, J
                 Else
                    pd.cpMin = Aspect + I - 1 : pd.cpMax = Aspect + lnLen
                    SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                    setRichTextColor cAssembler, J
                 End If
                 wFlag = 0
                 Exit For

              Case Else  'word is ready
                 If wFlag = 1 Then
                    xWord = Mid$(Buf, stopPos, I - stopPos)  'Get word
                    Result = 0

                    If BinaryWordSearch_Key(xWord,iPos) Then
                        xWord = Choose$(IIf(CodeCase<4,CodeCase,KeyCase),LKeys(iPos), MKeys(iPos), UKeys(iPos))
                        cWord = cKeyWord : Result = 1
                    ElseIf BinaryWordSearch_API(xWord,iPos) Then
                        xWord = Choose$(IIf(CodeCase<4,CodeCase,APICase),LAPI(iPos), MAPI(iPos), UAPI(iPos))
                        cWord = cAPI : Result = 1
                    ElseIf UseProcList And BinaryWordSearch_User(xWord,iPos) Then
                        xWord = Choose$(IIf(CodeCase<4,CodeCase,APICase),LUser(iPos), MUser(iPos), UUser(iPos))
                        cWord = cAPI : Result = 1
                    End If

                    If Result Then
                        pd.cpMin = Aspect + stopPos - 1  :  pd.cpMax = Aspect + I - 1
                        SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                        Control Send hDlg, %IDC_RichEdit, %EM_ReplaceSel, %True, StrPtr(xWord)

                        If LCase$(xWord) = "rem" Then  'extra for the uncomment word, REM
                           pd.cpMin = Aspect + I - 4  : pd.cpMax = Aspect + lnLen
                           SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                           setRichTextColor cRemark, J
                           Exit For
                        ElseIf LCase$(xWord) = "asm" Then  'extra for the uncomment word, ASM
                           stopPos = InStr(I + 1, Buf, Chr$(59)) 'look for assembler comment ;
                           If stopPos Then
                               'found a ; comment mark
                               'color assembler
                               pd.cpMin = Aspect + I - 4 : pd.cpMax = Aspect + stopPos - 1
                               SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                               setRichTextColor cAssembler, J
                               StopPos = (StopPos - I + 1)
                               I = I + StopPos
                               Letter = Letter + StopPos
                               'comment the rest
                               pd.cpMin = Aspect + I - 2  : pd.cpMax = Aspect + lnLen
                               SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                               setRichTextColor cRemark, J
                           Else
                               pd.cpMin = Aspect + I - 4 : pd.cpMax = Aspect + lnLen
                               SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                               setRichTextColor cAssembler, J
                           End If
                           Exit For
                        Else
                           SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                           setRichTextColor cWord, J
                        End If

                    ElseIf Verify(xWord, ".0123456789") = 0 Then
                       pd.cpMin = Aspect + stopPos - 1  : pd.cpMax = Aspect + I - 1
                       SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                       setRichTextColor cNumber, J
                    End If
                    wFlag = 0
                 End If

                 If HighLightSymbols Then
                     Select Case @Letter   'Chr$(@Letter)
                       Case  61, 42, 43, 45, 47, 92, 60, 62, 94, 40, 41   ' "=", "*", "+", "-", "/", "\", "<", ">", "^", "(",")"
                           pd.cpMin = Aspect + I - 1 : pd.cpMax = Aspect + I
                           SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                           setRichTextColor cSymbol, J
                       Case  38  ' "&"
                           If I>1 And I<lnlen And Peek(Letter-1)=32 And Peek(Letter+1)=32 Then
                               pd.cpMin = Aspect + I - 1  : pd.cpMax = Aspect + I
                               SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(pd))
                               setRichTextColor cSymbol, J
                           End If
                     End Select
                 End If
           End Select
           Incr Letter
        Next I
     End If
  Next J

  'Reset original caret position
  SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(Oldpd))

  'Turn on Redraw again and refresh - this one causes some flicker in Richedit..
'  SendMessage hRichEdit, %WM_SETREDRAW, 1, 0
  SendMessage hRichEdit, %EM_HideSelection, 0, 0
'  InvalidateRect hRichEdit, ByVal %NULL, 0 : UpdateWindow hRichEdit

  'Reset the event mask
  If xEvents Then SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, xEvents)

End Sub

Sub CreateVCode
  'Convert code to vBulletin encoded text
  'Parser builds syntax colored RTF. Use pointers and pre-allocated output string for speed
  Local ii As Long, stopPos As Long, Result As Long, iPos As Long
  Local wFlag As Long, remFlag As Long, dqFlag As Long, cWordStr As String, slashFlag As Long
  Local pLet As Byte Ptr, pLet2 As Byte Ptr
  Local tmpWord As String, vBuf As String, vCaseBuf As String

  MousePtr 11             'show Hourglass mouse pointer during process

  vCode = GetRichEditSelectedText
  If Len(vCode) = 0 Then Control Get Text hDlg, %IDC_RichEdit To vCode
  vCode = vCode + " "

  'starting blocks
  cKeyStr    = "[color=#" + Hex$(Bgr(cKeyword),6) + "]"    'Keys
  cRemStr    = "[color=#" + Hex$(Bgr(cRemark),6) + "]"    'Remarks
  cSymStr    = "[color=#" + Hex$(Bgr(cSymbol),6) + "]"    'Symbols
  cNumStr    = "[color=#" + Hex$(Bgr(cNumber),6) + "]"    'Numbers
  cASMStr    = "[color=#" + Hex$(Bgr(cAssembler),6) + "]"    'ASM
  cQuoStr    = "[color=#" + Hex$(Bgr(cQuote),6) + "]"    'Quotes
  cAPIStr    = "[color=#" + Hex$(Bgr(cAPI),6) + "]"    'API
  cUserStr   = "[color=#" + Hex$(Bgr(cAPI),6) + "]"    'User procedures
  cLenStr = Len(cKeyStr)

  'ending blocks
  endBlock   = "[/color]"  'block end
  endKey     = "[/colob]"  'use temporary block end for blue color, to enable size trim
  cLenEnd = Len(endBlock)

  vBuf     = String$(Max&(1000, 10 * Len(vCode)), 0) 'create enough big output buffer
  vCaseBuf = UCase$(vCode)          'use uppercase string for compare
  pLet     = StrPtr(vCode)          'pointer to global string (input)
  pLet2    = StrPtr(vBuf)        'pointer to output buffer

  For ii = 1 To Len(vCode)
     Select Case @pLet            'the characters we need to inlude in a word
        Case 65 To 90, 97 To 122, 35 To 37, 48 To 57, 63, 95, 46
           If wFlag = 0 And remFlag = 0 And dqFlag = 0 Then
              wFlag = 1 : stopPos = ii
           End If

        Case 34 ' double quote -> "
           If dqFlag = 0 And remFlag = 0 Then  'if start of string literal
              Poke$ pLet2, cQuoStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
              dqFlag = 1 : wFlag = 0                              'since now inside DQ, wordflag is off
           ElseIf dqFlag = 1 Then                                 'should be end of DQ block
              @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
              Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
              dqFlag = 3                                          'end of DQ - set DQ flag
           End If

        Case 59 ' asm comment character -> ;
           If remFlag = 0 And dqFlag = 2 Then
              Poke$ pLet2, endBlock   :  pLet2 = pLet2 + cLenEnd   'put endblock, move pointer
              Poke$ pLet2, cRemStr    :  pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              remFlag = 1 : wFlag = 0
           End If

        Case 39 ' uncomment character -> '
           If remFlag = 0 And dqFlag <> 1 Then
              If dqFlag = 2 Then
                 Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd   'put endblock, move pointer
              End If
              Poke$ pLet2, cRemStr     : pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              remFlag = 1 : wFlag = 0
           End If

        Case 33 ' asm line start -> !
           If remFlag = 0 And dqFlag = 0 Then
              Poke$ pLet2, cASMStr     : pLet2 = pLet2 + cLenStr   'put preblock, move pointer
              dqFlag = 2 : wFlag = 0
           End If

        Case Else  'word is ready
           If @pLet = 13 Then    'if CRLF - end of line
              If remFlag Or dqFlag Then   'if in rem, asm or unfinished string literal (DQ)
                 Poke$ pLet2, endBlock  : pLet2 = pLet2 + cLenEnd   'put value, move pointer
                 remFlag = 0 : wFlag = 0 : dqFlag = 0  'reset all flags
              End If
           End If

           If wFlag = 1 Then 'if we have a word
              tmpWord = Mid$(vCaseBuf, stopPos, ii - stopPos)  'Get word
              Result = 0

              If BinaryWordSearch_Key(tmpWord,iPos) Then
                  tmpWord = Choose$(IIf(CodeCase<4,CodeCase,KeyCase),LKeys(iPos), MKeys(iPos), UKeys(iPos))
                  cWordStr = cKeyStr : Result = 1
              ElseIf BinaryWordSearch_API(tmpWord,iPos) Then
                  tmpWord = Choose$(IIf(CodeCase<4,CodeCase,APICase),LAPI(iPos), MAPI(iPos), UAPI(iPos))
                  cWordStr = cAPIStr : Result = 1
              ElseIf UseProcList And BinaryWordSearch_User(tmpWord,iPos) Then
                  tmpWord = Choose$(IIf(CodeCase<4,CodeCase,APICase),LUser(iPos), MUser(iPos), UUser(iPos))
                  cWordStr = cUserStr : Result = 1
              End If

              If Result Then   'word match found (API, Keyword, User)
                 If tmpWord = "REM" Then
                    pLet2 = pLet2 - 3                                      'position to start of word
                    Poke$ pLet2, cRemStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                    Poke$ pLet2, tmpWord   : pLet2 = pLet2 + 3             'put value, move opinter
                    remFlag = 1
                 ElseIf tmpWord = "ASM" Then
                    pLet2 = pLet2 - 3                                      'position to start of word
                    Poke$ pLet2, cASMStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                    Poke$ pLet2, tmpWord   : pLet2 = pLet2 + 3             'put value, move pointer
                    dqFlag = 2
                 Else
                     pLet2 = pLet2 - Len(tmpWord)                          'position to start of word
                     Poke$ pLet2, cWordStr  : pLet2 = pLet2 + cLenStr      'put preblock, move pointer
                     Poke$ pLet2, tmpWord   : pLet2 = pLet2 + Len(tmpWord) 'put value, move pointer
                     Poke$ pLet2, endKey    : pLet2 = pLet2 + cLenEnd '15  'put endblock, move pointer
                 End If
              ElseIf Verify(tmpWord, ".0123456789") = 0 Then
                     pLet2 = pLet2 - Len(tmpWord) 'set position to start of word
                     Poke$ pLet2, cNumStr   : pLet2 = pLet2 + cLenStr       'put preblock, move pointer
                     Poke$ pLet2, tmpWord   : pLet2 = pLet2 + Len(tmpWord)  'put value, move pointer
                     Poke$ pLet2, endBlock  : pLet2 = pLet2 + cLenEnd       'put endblock, move pointer
              End If
              wFlag = 0
           End If
     End Select

     If dqFlag <> 3 Then
         If (remFlag = 0) And (dqFlag = 0) And HighlightSymbols Then
            Select Case @pLet   'Chr$(@Letter)
    '               =   *   +   -   /   <   >   ^   (  )
             Case  61, 42, 43, 45, 47, 60, 62, 94, 40, 41   ' 92=\ missing
                 Poke$ pLet2, cSymStr     : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                 @pLet2 = @pLet           : pLet2 = pLet2 + 1           'put value, move pointer
                 Poke$ pLet2, endBlock    : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
              Case  92  ' "\"
                 If slashFlag = 0 Then
                    Poke$ pLet2, cSymStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    slashFlag = 1
                 ElseIf Peek(pLet+1)<>92 Then
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
                    slashFlag = 0
                 Else
                    @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
                 End If
              Case  38  ' "&"
                 If Peek(pLet-1)=32 And Peek(pLet+1)=32 Then
                    Poke$ pLet2, cSymStr  : pLet2 = pLet2 + cLenStr     'put preblock, move pointer
                    @pLet2 = @pLet        : pLet2 = pLet2 + 1           'put char, move pointer
                    Poke$ pLet2, endBlock : pLet2 = pLet2 + cLenEnd     'put endblock, move pointer
                 Else
                    @pLet2 = @pLet        : Incr pLet2                  'put char, move pointer
                 End If
              Case Else
                 @pLet2 = @pLet           : Incr pLet2                  'put char, move pointer
            End Select
         Else
             @pLet2 = @pLet               :  Incr pLet2                 'put char, move pointer
         End If
     Else
        dqFlag = 0             'else reset DQ flag
     End If
     Incr pLet                 'move pointer to next character
  Next ii

  If remFlag Then Poke$ pLet2, endBlock

  vCode = Extract$(vBuf, Chr$(0))     'extract result (and remove the added space)
  Replace endKey + " " + cKeyStr With " " In vCode    'Trim size: If keywords follows each other,
  Replace endKey With endBlock In vCode               'replace remaining Key endblocks with proper RTF

  CreateRTFPrefix      'restore the prefix stuff that was overwritten by this code

  MousePtr 1       'done, so time to reset mouse pointer

End Sub

Sub DisplayCodeInfo
    Local temp$
    BuildProcedureList
    Control Get Text hDlg, %IDC_RichEdit To temp$
    If Trim$(temp$) = "" Then
       MsgBox "Characters: " + Str$(Len(temp$)) + $CrLf + $CrLf + "Line Count:  0" + $CrLf + $CrLf + "Procedures:  0", %MB_Ok = %MB_IconInformation, "Code Summary"
    Else
       MsgBox "Characters: " + Str$(Len(temp$)) + $CrLf + $CrLf + "Line Count: " + Str$(ParseCount(temp$,$CrLf)) + _
          $CrLf + $CrLf + "Procedures: " + Str$(UBound(MUser)+1) + $CrLf + "  " + Join$(MUser(),$CrLf + "  "), %MB_Ok = %MB_IconInformation, "Code Summary"
    End If
End Sub

Sub SetToolTip(hControl As Dword, TipText As Asciiz*256)
      Local TI As TOOLINFO
      TI.cbSize    = Len(TI)
      TI.uFlags    = %TTF_SUBCLASS Or %TTF_IDISHWND
      TI.hWnd      = GetParent(hToolTip)
      TI.uId       = hControl
      TI.lpszText  = VarPtr(TipText)
      SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)
End Sub

Sub DisplayFindDialog()
     Local style&, x,y As Long, temp$
     style& = %WS_TabStop Or %WS_Border Or %WS_Visible Or %ES_Left Or %ES_AutoHScroll Or %ES_WantReturn

     'use selection, if any, as SearchTerm$
     Control Send hDlg, %IDC_RichEdit, %EM_GETSEL, VarPtr(x), VarPtr(y)
     If x <> y Then
         Control Get Text hDlg, %IDC_RichEdit To temp$
         SearchTerm$ = Mid$(temp$, x, y-x+1)
     End If

     Dialog New Pixels, hDlg, "Find & Replace", 250, 200, 330, 70, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
     Dialog Set Icon hSearch, "aainfo"

     Control Add Label, hSearch, %IDC_Label, "Find This:", 5, 10, 60, 20
     Control Add Label, hSearch, %IDC_Label, "Replace With:", 5, 40, 70, 20

     Control Add TextBox, hSearch, %IDC_FindText, SearchTerm$, 80, 10, 185, 20, style&
     Control Add ImgButton, hSearch, %IDC_Down, "downhand", 270, 10, 25, 25, %WS_Child Or %WS_Visible Or %WS_TabStop Or %WS_Border
     Control Add ImgButton, hSearch, %IDC_Up, "uphand", 300, 10, 25, 25, %WS_Child Or %WS_Visible Or %WS_TabStop Or %WS_Border
     Control Add TextBox, hSearch, %IDC_ReplaceText, ReplaceTerm$, 80, 40, 185, 20, style&
     Control Add Button, hSearch, %IDC_Replace, "Replace", 270, 40, 55, 20, %WS_TabStop

     fFindShown = 1

     Dialog Show Modeless hSearch Call SearchProc()

     Do
         Dialog DoEvents
     Loop Until fFindShown = 0
End Sub

CallBack Function SearchProc() As Long
    Local x As Long, y As Long
    Select Case Cb.Msg
       Case %WM_SYSCOMMAND
          If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
             Control Set Focus hDlg, %IDC_RichEdit
          End If
       Case %WM_Destroy
           fFindShown = 0
       Case %WM_Command
          Select Case Cb.Ctl
             Case %IdCancel
                fFindShown = 0
                Dialog End hSearch
             Case %IDC_Replace           'replace selected text
                Control Get Text hSearch, %IDC_FindText To SearchTerm$
                Control Get Text hSearch, %IDC_ReplaceText To ReplaceTerm$
                Control Send hDlg, %IDC_RichEdit, %EM_GETSEL, VarPtr(x), VarPtr(y)
                If x <> y Then    'apply only to a selection
                   Control Send hDlg, %IDC_RichEdit, %EM_ReplaceSel, %True, StrPtr(ReplaceTerm$)
                   FindTextInRichEdit 1                    '1 means forward search
                Else
                   Beep   'no selection
                End If
             Case %IDC_Down
                Control Get Text hSearch, %IDC_FindText To SearchTerm$
                FindTextInRichEdit 1                    '1 means forward search
             Case %IDC_Up
                Control Get Text hSearch, %IDC_FindText To SearchTerm$
                FindTextInRichEdit 0                   '0 means backward search
          End Select
    End Select
End Function

Sub FindTextinRichEdit(iDirection&)  'SearchTerm$, SearchStart& are global
   Local temp$, P As CharRange, sTerm$
   Control Get Text hDlg, %IDC_RichEdit To temp$                   'get text from RichEdit
   Control Send hDlg, %IDC_RichEdit, %EM_ExGetSel, 0, VarPtr(P)    'get caret/selection boundaries
   sTerm$ = LCase$(SearchTerm$) : temp$ = LCase$(temp$)
   SearchStart& = InStr(IIf(iDirection&, P.cpMax+1, -1*(Len(temp$)-P.cpMin)), temp$, sTerm$)
   If SearchStart& Then
      P.cpMin = SearchStart& - 1
      P.cpMax = SearchStart& + Len(sTerm$) - 1
      Control Send hDlg, %IDC_RichEdit, %EM_ExSetSel, 0, VarPtr(P)
   Else
      Beep
   End If
End Sub

Function GetRichEditSelectedText() As String
    Dim temp$, x As Long, y As Long
    Control Get Text hDlg, %IDC_RichEdit To temp$
    Control Send hDlg, %IDC_RichEdit, %EM_GETSEL, VarPtr(x), VarPtr(y)
    Function = Mid$(temp$, x+1, y-x)
End Function

Function GetDroppedFileName(hDrop As Dword) As String
   'David Gwillim July 2005
   Local fString As Asciiz*%MAX_PATH, Count As Long
   fString=Space$(%MAX_PATH)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                           ' put Count chars into result string
End Function

Sub OpenSelectedFile(filevar$)
    Local temp$
    LastOpenedFile = filevar$
    Open LastOpenedFile For Binary As #1
    Get$ #1, Lof(1), temp$
    Close #1
    Control Set Text hDlg, %IDC_RichEdit, temp$
    If UseProcList Then BuildProcedureList
    FullSyntax
End Sub

Function GetLinkInfo(LinkPath As String ) As String
   Local CLSID_ShellLink, IID_IShellLink As GUIDAPI
   Local CLSCTX_INPROC_SERVER, Flags, lResult As Dword
   Local FileData As WIN32_FIND_DATA
   Local IID_Persist As String * 16, pp, ppf, psl As Dword Ptr
   Local outvalue, TmpAsciiz As Asciiz * %MAX_PATH
   Local TmpWide As Asciiz * ( 2 * %MAX_PATH )
   Poke$ VarPtr(CLSID_ShellLink), Mkl$( &H00021401 ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   Poke$ VarPtr(IID_IShellLink), Mkl$( &H000214EE ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   IID_Persist = Mkl$( &H0000010B ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   CLSCTX_INPROC_SERVER = 1
   If IsFalse( CoCreateInstance(CLSID_ShellLink, ByVal %NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, psl )) Then
      pp = @psl: Call Dword @pp Using Sub3( ByVal psl, IID_Persist, ppf ) To lResult
      TmpAsciiz = LinkPath
      MultiByteToWideChar %CP_ACP, 0, TmpAsciiz, %MAX_PATH, ByVal VarPtr(TmpWide), 2 * %MAX_PATH
      pp = @ppf + 20: Call Dword @pp Using Sub3( ByVal ppf, TmpWide, ByVal %TRUE )
      pp = @psl + 12: Call Dword @pp Using Sub5( ByVal psl, outvalue, ByVal %MAX_PATH, FileData, Flags )  'GetFilePath
      pp = @ppf + 8: Call Dword @pp Using Sub1( ByVal ppf )      'Release the persistant file
      pp = @psl + 8: Call Dword @pp Using Sub1( ByVal psl )      'Unbind the shell link object from the persistent file
      Function = outvalue
   End If
   CoUninitialize
End Function

Sub PrintCode
    Local iReturn As Long, temp$
    FullSyntax
    temp$ = gTxt
    Replace "\par " With "\line " In temp$    'RTF likes this kind of line feed better
    Open EXE.Path$ + "gbforumcode_temp.rtf" For Output As #1
    Print #1, temp$
    Close #1
    iReturn = Shell("write.exe /p " + EXE.Path$ + "gbforumcode_temp.rtf", 2)    'does not wait
End Sub

Function CodeIndent() As String
   Local temp$, N,B,P As Long    'N is indentation, B is max blank lines
   Local D() As String, i, j, Flag, iCount, iMax, cFlag As Long   'cFlag = continuation flag
   Local iSelectLevel&, iDoLevel&, iForLevel&, iIfLevel&, iWhileLevel&
   Local iLevel&, iInterfaceLevel&, iMethodLevel&, iPropertyLevel&, iTryLevel&

   Dim SelectLevel(100) As Long
   Dim DoLevel(100) As Long
   Dim ForLevel(100) As Long
   Dim IfLevel(100) As Long
   Dim WhileLevel(100) As Long
   Dim TryLevel(100) As Long
   Dim InterfaceLevel(100) As Long
   Dim MethodLevel(100) As Long
   Dim PropertyLevel(100) As Long

   Control Get Text hDlg, %IDC_RichEdit To temp$
   N = 4 : B = 1 : P = 1

   Replace $Tab With Space$(N) In temp$
   i = ParseCount(temp$, $CrLf)
   ReDim D(i-1)
   Parse temp$, D(), $CrLf

   'Trim excess white space, but leave white space on right (left-justifies all text)
   For i = 0 To UBound(D)
      D(i) = Trim$(D(i)) + " "
   Next i

   'blank line management  B = max number of allowed blank lines between any 2 lines of code
   If B > -1 Then
      For i = UBound(D) To 0 Step -1
         If Len(Trim$(D(i))) = 0 Then
            Incr iCount
            If iCount > B Then
               Array Delete D(i)
               ReDim Preserve D(UBound(D)-1)
               Decr iCount
            End If
         Else
            iCount = 0
         End If
      Next i
   End If

   'pre-construct blank line addition   P = exact number of blank lines required before construct
   If P > -1 Then
      iCount = 0 : iMax = UBound(D)
      For i = iMax To 1 Step -1
         If LCase$(Left$(D(i),5)) = "type " Or _
               LCase$(Left$(D(i),6)) = "union " Or _
               LCase$(Left$(D(i),4)) = "sub " Or _
               LCase$(Left$(D(i),16)) = "thread function " Or _
               LCase$(Left$(D(i),9)) = "callback " Or _
               (LCase$(Left$(D(i),9)) = "function " And LCase$(Left$(D(i),10)) <> "function =") Or _
               (LCase$(Left$(D(i),6)) = "class " And LCase$(Left$(D(i),10)) <> "function =") Then
            iCount = 0 : Flag = 1

         ElseIf Len(Trim$(D(i))) = 0 Then
            If Flag Then Incr iCount

         Else
            If Flag Then
               Select Case iCount
                  Case P            'no action
                  Case Is < P       'add P-iCount lines
                     ReDim Preserve D(UBound(D) + P - iCount)
                     For j = 1 To (P-iCount) : Array Insert D(i+1) : Next j
                  Case Is > P        'delete iCount - P line
                     For j = 1 To (iCount-P) : Array Delete D(i+1) : Next j
                     ReDim Preserve D(UBound(D) - (iCount - P))
               End Select
            End If
            Flag = 0 : iCount = 0
         End If
      Next i
   End If

   For i = 0 To UBound(D)
      temp$ = LCase$(RTrim$(TrimComments(D(i))))'used in test merged multi-line code
      If cFlag Then    'previous line ended in _ so use this line as is, with indentation to iLevel + 1
         D(i) = Space$((iLevel+1)*N) + D(i) 'keep current indentation

      ElseIf LCase$(Left$(D(i),6)) = "macro " Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),5)) = "type " Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),8)) = "end type" Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),6)) = "union " Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),9)) = "end union" Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),4)) = "sub " Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),7)) = "end sub" Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),16)) = "thread function " Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),9)) = "callback " Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),9)) = "function " And LCase$(Left$(D(i),10)) <> "function =" Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),12)) = "end function" Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),6)) = "class " And LCase$(Left$(D(i),10)) <> "function =" Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1
      ElseIf LCase$(Left$(D(i),9)) = "end class" Then
         iLevel=1 : iIFLevel&=1 : iForLevel&=1 : iSelectLevel&=1 : iDoLEvel&=1 : iWhileLevel&=1

         '****** This section tests for multi-line structures merged on a single line ***************************
         'such structures have no children, so the iLevel is not changed and the line is used as is *************


      ElseIf Left$(temp$,3) = "if " And InStr(-1,temp$,"then ") And Len(Mid$(temp$,InStr(-1,temp$,"then ")+5)) > 0 Then
         'Tests for:  If x then y=2
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,3) = "if " And InStr(-1,temp$,"else ") And Len(Mid$(temp$,InStr(-1,temp$,"else ")+5)) > 0 Then
         D(i) = Space$(iLevel*N) + D(i)
         'Tests for:  If x then y=2 else z=4
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,4) = "for " And InStr(-1,temp$,"next ") And Len(Mid$(temp$,InStr(-1,temp$,"next ")+5)) > 0 Then
         'Tests for:  For x=2 To 5 : next i
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,6) = "macro " And Right$(temp$,9) = "end macro" Then
         'Tests for:  macro : ... : ... : end macro
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,4) = "try " And Right$(temp$,7) = "end try" Then
         'Tests for:  try : ... : ... : end try
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,3) = "do " And Right$(temp$,4) = "loop" Then
         'Tests for:  do loop/while : ... : ... : loop
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,3) = "do " And InStr(-1,temp$,"loop while ") And Len(Mid$(temp$,InStr(-1,temp$,"loop while ")+11)) > 0 Then
         'Tests for:  Do .. : .. : Loop While x=2
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,3) = "do " And InStr(-1,temp$,"loop until ") And Len(Mid$(temp$,InStr(-1,temp$,"loop until ")+11)) > 0 Then
         'Tests for:  Do .. : .. : Loop While x=2
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,6) = "while " And Right$(temp$,4) = "wend" Then
         'Tests for:  While x=2 : y=3 : Wend
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,11) = "select case" And Right$(temp$,10) = "end select" Then
         'Tests for: Select Case x : ... : End Select
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,10) = "interface " And Right$(temp$,9) = "interface" Then
         'Tests for:  Interface ... End Interface
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,7) = "method" And Right$(temp$,10) = "end method" Then
         'Tests for:  Method ... End Method
         D(i) = Space$(iLevel*N) + D(i)

      ElseIf Left$(temp$,10) = "property " And Right$(temp$,12) = "end property" Then
         'Tests for:  Property ... End Property
         D(i) = Space$(iLevel*N) + D(i)

         '********* This section handles each line of multi-line constructs *********************

         'do/loop
      ElseIf LCase$(Left$(D(i),3)) = "do " Then
         Incr iDoLevel& : DoLevel(iDoLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),5)) = "loop " Then
         iLevel = DoLevel(iDoLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iDoLevel&

         'for/next
      ElseIf LCase$(Left$(D(i),4)) = "for " Then
         Incr iForLevel& : ForLevel(iForLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),5)) = "next " Then
         iLevel = ForLevel(iForLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iForLevel&

         'if/elseif/else/end if
      ElseIf LCase$(Left$(D(i),3)) = "if " Then
         Incr iIFLevel& : IFLevel(iIFLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),7)) = "elseif " Then
         iLevel = IFLevel(iIFLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),4)) = "else" Then
         iLevel = IFLevel(iIFLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),6)) = "end if" Then
         iLevel = IFLevel(iIFLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iIFLevel&

         'try/catch/finally/end try
      ElseIf LCase$(Left$(D(i),4)) = "try " Then
         Incr iTryLevel& : TryLevel(iTryLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),5)) = "catch" Then
         iLevel = TryLevel(iTryLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),7)) = "finally" Then
         iLevel = TryLevel(iTryLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),7)) = "end try" Then
         iLevel = TryLevel(iTryLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iTryLevel&

         'select case/end select
      ElseIf LCase$(Left$(D(i),7)) = "select " Then
         Incr iSelectLevel& : SelectLevel(iSelectLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),5)) = "case " Then
         iLevel = SelectLevel(iSelectLevel&)+1
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),10)) = "end select" Then
         iLevel = SelectLevel(iSelectLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iSelectLevel&

         'while/wend
      ElseIf LCase$(Left$(D(i),6)) = "while " Then
         Incr iWhileLevel& : WhileLevel(iWhileLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),4)) = "wend" Then
         iLevel = WhileLevel(iWhileLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iWhileLevel&

         'interface/endinterface
      ElseIf LCase$(Left$(D(i),10)) = "interface " Then
         Incr iInterfaceLevel& : InterfaceLevel(iInterfaceLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),13)) = "end interface" Then
         iLevel = InterfaceLevel(iInterfaceLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iInterfaceLevel&

         'property/endproperty
      ElseIf LCase$(Left$(D(i),9)) = "property " Then
         Incr iPropertyLevel& : PropertyLevel(iPropertyLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),12)) = "end property" Then
         iLevel = PropertyLevel(iPropertyLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iPropertyLevel&

         'method/endmethod
      ElseIf LCase$(Left$(D(i),7)) = "method " Then
         Incr iMethodLevel& : MethodLevel(iMethodLevel&) = iLevel
         D(i) = Space$(iLevel*N) + D(i)
         Incr iLevel
      ElseIf LCase$(Left$(D(i),10)) = "end method" Then
         iLevel = MethodLevel(iMethodLevel&)
         D(i) = Space$(iLevel*N) + D(i)
         Decr iMethodLevel&

         'labels
      ElseIf InStr(D(i),":") And Verify(Left$(D(i),InStr(D(i),":")-1), Chr$(65 To 90, 97 To 122, 48 To 57, 95)) = 0 Then
         'no indentation

      Else
         D(i) = Space$(iLevel*N) + D(i)
      End If
      D(i) = RTrim$(D(i))

      If Right$(temp$,1) = "_" Then cFlag = 1 Else cFlag = 0

   Next i

   Control Set Text hDlg, %IDC_RichEdit, Join$(D(), $CrLf)
End Function

Function TrimComments(txt As String) As String
   Local i, qFlag As Long, c As String
   For i = 1 To Len(txt)
      c = Mid$(txt,i,1)
      If c = $Dq And qFlag = 1 Then
         qFlag = 0
      ElseIf c = $Dq Then
         qFlag = 1
      ElseIf c = "'" And qFlag = 0 Then
         Function = RTrim$(Left$(txt,i-1))   'found single-quote character not embedded in double-quotes
         Exit Function
      End If
   Next i
   Function = txt
End Function
